Status Set_BmpAlpha(Bitmap *Bmp_W, int indexOpe, BYTE nAlpha);
Status Set_BmpAlphaReverse(Bitmap *Bmp_W);
Status Set_BmpAlphaGra(Bitmap *Bmp_W, int indexOpe, int indexGrad);
Status Set_BmpAlphaBmp(Bitmap *Bmp_W, int indexOpe, Bitmap *Bmp_R);

// 摜̓xύXilj
// Bmp_W    : [IN][OUT] xύX摜
// indexOpe : [IN]      0:u, 1:Z, 2:Z, 3:ŏl, 4:ől, 5:
// nAlpha   : [IN]      ݒ肷铧xi0 ` 255j
Status Set_BmpAlpha(Bitmap *Bmp_W, int indexOpe, BYTE nAlpha)
{
	Status		st = GenericError;
	
	if(!Bmp_W){
		return st;
	}
	
	if(nAlpha < 0)			nAlpha = 0;
	else if(nAlpha > 255)	nAlpha = 255;
	int nAlpha2 = 255 - nAlpha;
	
	UINT		wdh = Bmp_W->GetWidth();
	UINT		hgt = Bmp_W->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	BitmapData	bitmapData;
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// rbg̏
	st = Bmp_W->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels = NULL;	// 32bppFf
		UINT	stride;			// f[^4byteE
		UINT	x,y,pos;
		Color	clr;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride = abs(bitmapData.Stride);
		
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				pos = y*stride+x*4;
				switch (indexOpe)
				{
				case 0:
					pixels[pos+3] = nAlpha;
					break;
				case 1:
					{
						int val = pixels[pos+3] - nAlpha2;
						if(val < 0)
							val = 0;
						pixels[pos+3] = (BYTE) val;
					}
					break;
				case 2:
					{
						int val = pixels[pos+3] + nAlpha2;
						if(val > 255)
							val = 255;
						pixels[pos+3] = (BYTE) val;
					}
					break;
				case 3:
					{
						int val = __min(pixels[pos+3], nAlpha);
						if(val > 255)
							val = 255;
						pixels[pos+3] = (BYTE) val;
					}
					break;
				case 4:
					{
						int val = __max(pixels[pos+3], nAlpha);
						if(val > 255)
							val = 255;
						pixels[pos+3] = (BYTE) val;
					}
					break;
				case 5:
					{
						int val = (pixels[pos+3] + nAlpha) >> 1;
						if(val > 255)
							val = 255;
						pixels[pos+3] = (BYTE) val;
					}
					break;
				}
			}
		}
		
		st = Bmp_W->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	SetCursor(hCurPre);
	
	return st;
}// Set_BmpAlpha

// 摜̓xύXi]j
// Bmp_W  : [IN][OUT] xύX摜
Status Set_BmpAlphaReverse(Bitmap *Bmp_W)
{
	Status		st = GenericError;
	
	if(!Bmp_W){
		return st;
	}
	
	UINT		wdh = Bmp_W->GetWidth();
	UINT		hgt = Bmp_W->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	BitmapData	bitmapData;
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// rbg̏
	st = Bmp_W->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels = NULL;	// 32bppFf
		UINT	stride;			// f[^4byteE
		UINT	x,y,pos;
		Color	clr;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride = abs(bitmapData.Stride);
		
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				pos = y*stride+x*4;
				pixels[pos+3] = 255 - pixels[pos+3];
			}
		}
		
		st = Bmp_W->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	SetCursor(hCurPre);
	
	return st;
}// Set_BmpAlphaReverse

// 摜̓xύXiOf[Vj
// Bmp_W     : [IN][OUT] xύX摜
// indexOpe  : [IN]      0:u, 1:Z, 2:Z, 3:ŏl, 4:ől, 5:
// indexGrad : [IN]      Of[V̎ށi0 ` 15j
Status Set_BmpAlphaGra(Bitmap *Bmp_W, int indexOpe, int indexGrad)
{
	Status		st = GenericError;
	
	if(!Bmp_W){
		return st;
	}
	
	UINT		wdh = Bmp_W->GetWidth();
	UINT		hgt = Bmp_W->GetHeight();
	PixelFormat	fmt = PixelFormat24bppRGB;
	Rect		rect(0, 0, wdh, hgt);
	BitmapData	bitmapDataR,bitmapDataW;
	Bitmap		Bmp_R(wdh, hgt, fmt);
	Graphics	gBmp(&Bmp_R);
	
	if(indexGrad < 8){
		Point	pt1,pt2;
		Color	clr1,clr2;
		switch (indexGrad)
		{
		case 0:	// 
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = 0;
			pt2.Y = hgt;
			clr1 = Color(255,255,255);
			clr2 = Color(0,0,0);
			break;
		case 1:	// 
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = 0;
			pt2.Y = hgt;
			clr1 = Color(0,0,0);
			clr2 = Color(255,255,255);
			break;
		case 2:	// E
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = wdh;
			pt2.Y = 0;
			clr1 = Color(255,255,255);
			clr2 = Color(0,0,0);
			break;
		case 3:	// 
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = wdh;
			pt2.Y = 0;
			clr1 = Color(0,0,0);
			clr2 = Color(255,255,255);
			break;
		case 4:	// E΂߉
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = wdh;
			pt2.Y = hgt;
			clr1 = Color(255,255,255);
			clr2 = Color(0,0,0);
			break;
		case 5:	// ΂ߏ
			pt1.X = 0;
			pt1.Y = 0;
			pt2.X = wdh;
			pt2.Y = hgt;
			clr1 = Color(0,0,0);
			clr2 = Color(255,255,255);
			break;
		case 6:	// ΂߉
			pt1.X = wdh;
			pt1.Y = 0;
			pt2.X = 0;
			pt2.Y = hgt;
			clr1 = Color(255,255,255);
			clr2 = Color(0,0,0);
			break;
		case 7:	// E΂ߏ
			pt1.X = wdh;
			pt1.Y = 0;
			pt2.X = 0;
			pt2.Y = hgt;
			clr1 = Color(0,0,0);
			clr2 = Color(255,255,255);
			break;
		}
		LinearGradientBrush	brush(pt1, pt2, clr1, clr2);
		gBmp.FillRectangle(&brush, rect);
	}
	else{
		GraphicsPath	path(FillModeAlternate);
		Color			clr_center;
		Color			clr_out;
		Color			*clr_surrnd = NULL;
		SolidBrush		brush2(Color(255,255,255));
		
		int diameter = wdh < hgt ? wdh : hgt;
		int x2,y2;
		if(wdh >= hgt){
			x2 = (wdh - diameter) / 2;
			y2 = 0;
		}
		else{
			x2 = 0;
			y2 = (hgt - diameter) / 2;
		}
		Rect rect2(x2, y2, diameter, diameter);
		
		switch (indexGrad)
		{
		case 8:		// `iOj
			path.AddRectangle(rect);
			clr_center = Color(255,255,255);
			clr_out = Color(0,0,0);
			break;
		case 9:		// `ij
			path.AddRectangle(rect);
			clr_center = Color(0,0,0);
			clr_out = Color(255,255,255);
			break;
		case 10:	// ȉ~iOj
			path.AddEllipse(rect);
			clr_center = Color(255,255,255);
			clr_out = Color(0,0,0);
			break;
		case 11:	// ȉ~ij
			path.AddEllipse(rect);
			clr_center = Color(0,0,0);
			clr_out = Color(255,255,255);
			gBmp.FillRectangle(&brush2, rect);
			break;
		case 12:	// `iOj
			path.AddRectangle(rect2);
			clr_center = Color(255,255,255);
			clr_out = Color(0,0,0);
			break;
		case 13:	// `ij
			path.AddRectangle(rect2);
			clr_center = Color(0,0,0);
			clr_out = Color(255,255,255);
			gBmp.FillRectangle(&brush2, rect);
			break;
		case 14:	// ~iOj
			path.AddEllipse(rect2);
			clr_center = Color(255,255,255);
			clr_out = Color(0,0,0);
			break;
			
		case 15:	// ~ij
			path.AddEllipse(rect2);
			clr_center = Color(0,0,0);
			clr_out = Color(255,255,255);
			gBmp.FillRectangle(&brush2, rect);
			break;
		}
		PathGradientBrush brush(&path);
		int count = brush.GetPointCount();
		clr_surrnd = new Color [count];
		for(int i=0;i<count;i++){
			clr_surrnd[i] = clr_out;
		}
		brush.SetCenterColor(clr_center);
		brush.SetSurroundColors(clr_surrnd, &count);
		SAFE_DELETE_ARRAY(clr_surrnd);
		gBmp.FillPath(&brush, &path);
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// rbg̓ǂݍ
	st = Bmp_R.LockBits(&rect, ImageLockModeRead, fmt, &bitmapDataR);
	if (st == Ok)
	{
		BYTE	*pixelsR = NULL;	// 32bppFf
		UINT	strideR;			// f[^4byteE
		
		if (bitmapDataR.Stride > 0)
			pixelsR = (BYTE*) bitmapDataR.Scan0;
		else
			pixelsR = (BYTE*) bitmapDataR.Scan0
					+ (bitmapDataR.Stride)*(bitmapDataR.Height-1);
		
		strideR = abs(bitmapDataR.Stride);
		
		// rbg̏
		st = Bmp_W->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, PixelFormat32bppARGB, &bitmapDataW);
		if (st == Ok)
		{
			BYTE	*pixelsW = NULL;	// 32bppFf
			UINT	strideW;			// f[^4byteE
			UINT	x,y,posW,posR;
			Color	clr;
			
			if (bitmapDataW.Stride > 0)
				pixelsW = (BYTE*) bitmapDataW.Scan0;
			else
				pixelsW = (BYTE*) bitmapDataW.Scan0
						+ (bitmapDataW.Stride)*(bitmapDataW.Height-1);
			
			strideW = abs(bitmapDataW.Stride);
			
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh; x++){
					posR = y*strideR+x*3;
					posW = y*strideW+x*4;
					switch (indexOpe)
					{
					case 0:
						pixelsW[posW+3] = pixelsR[posR+0];
						break;
					case 1:
						{
							int val = pixelsW[posW+3] - (255 - pixelsR[posR+0]);
							if(val < 0)
								val = 0;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 2:
						{
							int val = pixelsW[posW+3] + (255 - pixelsR[posR+0]);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 3:
						{
							int val = __min(pixelsW[posW+3], pixelsR[posR+0]);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 4:
						{
							int val = __max(pixelsW[posW+3], pixelsR[posR+0]);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 5:
						{
							int val = (pixelsW[posW+3] + pixelsR[posR+0]) >> 1;
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					}
				}
			}
			
			st = Bmp_W->UnlockBits(&bitmapDataW);
			if(st != Ok){
				MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
			}
		}
		else{
			MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
		}
		st = Bmp_R.UnlockBits(&bitmapDataR);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
	}
	
	SetCursor(hCurPre);
	
	return st;
}// Set_BmpAlphaGra

// 摜̓xύXỉ摜j
// Bmp_W    : [IN][OUT] xύX摜
// Bmp_R    : [IN]      xǂݍމ摜
// indexOpe : [IN]      0:u, 1:Z, 2:Z, 3:ŏl, 4:ől, 5:
// bAlpha   : [IN]      0:x, 1:x
Status Set_BmpAlphaBmp(Bitmap *Bmp_W, Bitmap *Bmp_R, int indexOpe, bool bAlpha)
{
	Status		st = GenericError;
	
	if(!Bmp_W || !Bmp_R){
		return st;
	}
	
	UINT		wdhW = Bmp_W->GetWidth();
	UINT		hgtW = Bmp_W->GetHeight();
	UINT		wdhR = Bmp_R->GetWidth();
	UINT		hgtR = Bmp_R->GetHeight();
	UINT		wdh = wdhW <= wdhR ? wdhW : wdhR;
	UINT		hgt = hgtW <= hgtR ? hgtW : hgtR;
	Rect		rect(0, 0, wdh, hgt);
	BitmapData	bitmapData;
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// rbg̏
	st = Bmp_W->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixelsW = NULL;	// 32bppFf
		UINT	strideW;			// f[^4byteE
		UINT	x,y,posW;
		Color	clr;
		
		if (bitmapData.Stride > 0)
			pixelsW = (BYTE*) bitmapData.Scan0;
		else
			pixelsW = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		strideW = abs(bitmapData.Stride);
		
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				posW = y*strideW+x*4;
				Bmp_R->GetPixel(x, y, &clr);
				if(bAlpha){
					switch (indexOpe)
					{
					case 0:
						pixelsW[posW+3] = clr.GetA();
						break;
					case 1:
						{
							int val = pixelsW[posW+3] - (255 - clr.GetA());
							if(val < 0)
								val = 0;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 2:
						{
							int val = pixelsW[posW+3] + (255 - clr.GetA());
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 3:
						{
							int val = __min(pixelsW[posW+3], clr.GetA());
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 4:
						{
							int val = __max(pixelsW[posW+3], clr.GetA());
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 5:
						{
							int val = (pixelsW[posW+3] + clr.GetA()) >> 1;
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					}
				}
				else{
					double luminance =	(clr.GetR() * 0.299) +
										(clr.GetG() * 0.587) +
										(clr.GetB() * 0.114);
					switch (indexOpe)
					{
					case 0:
						pixelsW[posW+3] = (BYTE) luminance;
						break;
					case 1:
						{
							int val = pixelsW[posW+3] - (255 - (BYTE) luminance);
							if(val < 0)
								val = 0;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 2:
						{
							int val = pixelsW[posW+3] + (255 - (BYTE) luminance);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 3:
						{
							int val = __min(pixelsW[posW+3], (BYTE) luminance);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 4:
						{
							int val = __max(pixelsW[posW+3], (BYTE) luminance);
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					case 5:
						{
							int val = (pixelsW[posW+3] + (BYTE) luminance) >> 1;
							if(val > 255)
								val = 255;
							pixelsW[posW+3] = (BYTE) val;
						}
						break;
					}
				}
			}
		}
		
		st = Bmp_W->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_WbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	SetCursor(hCurPre);
	
	return st;
}// Set_BmpAlphaBmp
