Status	Bucket32(Bitmap *Bmp, Point pos, Color clr_aft, int da, int dr, int dg, int db);
bool	Bucket32_Sub   (BYTE *pxl2, BYTE *pxl3, int wdh, int hgt, BYTE a, BYTE r, BYTE g, BYTE b, int da, int dr, int dg, int db);
POINT	Bucket32_Sub_x(BYTE *pxl2, BYTE *pxl3, int wdh, int hgt, int xPos, int yPos, BYTE a, BYTE r, BYTE g, BYTE b, int da, int dr, int dg, int db);
Status	Magic_Wand(Bitmap *Bmp, GraphicsPath *path, Point pos, 
					int da, int dr, int dg, int db, bool flag_reverse);
Point	Search_FirstPt(BYTE *pxl, int wdh, int hgt, int x, int y);
void	Search_NextPt(BYTE *pxl, int wdh, int hgt, int x, int y);
void	Search_NextPt2(BYTE *pxl, int wdh, int hgt, int x, int y);
Status	Draw_ArrowPath(Graphics *g, GraphicsPath *path, int wdh, int hgt, int dx, int dy, 
						FillMode fillmode, int zoom, Pen *pen_w, Pen *pen_b);
Status	Draw_PenThick(Graphics *g, GraphicsPath *path, Bitmap *BmpDot, Point pos, 
					  int wdh, int hgt, int dx, int dy, int zoom, Pen *pen1, Pen *pen2);
Status	Draw_ZoomPath(Bitmap *Bmp, PixelFormat pfmt, GraphicsPath *path, Rect rcDot, 
					 int dx, int dy, int zoom);
void	Set_SafePos(Point *pt, int wdh, int hgt);
BYTE	Get_FlagPixel(BYTE *pxl, UINT stride, int wdh, int hgt, int x, int y, int rgb);
BYTE	Get_FlagPixel(BYTE *pxl, int wdh, int hgt, int x, int y);
bool	Compare_Argb(BYTE a1, BYTE r1, BYTE g1, BYTE b1, BYTE a2, BYTE r2, BYTE g2, BYTE b2, int da, int dr, int dg, int db);
bool	Check_StackSize();
bool	Check_MagicMemorySize();

const POINT g_pt1[9] = {{0,1},{-1,1},{-1,0},{-1,-1},{0,-1},{1,-1},{1,0},{1,1},{0,1}};	// 8ߖT̑΍Wi}WbNhpj
const POINT g_pt2[4] = {{-1,0},{0,-1},{1,0},{0,1}}; 	// 4ߖT̑΍Wi}WbNhpj

BYTE	g_slant_pre = -1;	// 1O̗֊sW̌Xig_pt1[] ƓB-1 ͏ԁj

// }WbNh̍Wf[^
typedef struct{
	Point	*pt;		// W
	int 	num;		// pt̐
}MGC,*LPMGC;

MGC g_mgc1 = {0};

// ێX^bN
POINT	*g_pt_stack = NULL;
int 	g_num_stack = 0;

// hԂi24,32bitFj
// Bmp	  : [IN][OUT] hԂΏۂ̉摜
// pos	  : [IN]	  NbNꂽsNZʒu
// clr_aft: uF
Status Bucket32(Bitmap *Bmp, Point pos, Color clr_aft, int da, int dr, int dg, int db)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	int 		wdh  = Bmp->GetWidth();
	int 		hgt  = Bmp->GetHeight();
	PixelFormat pfmt = Bmp->GetPixelFormat();
	int 		bpp  = PxFmtToBpp(pfmt);
	Rect		rect(0, 0, wdh, hgt);
	BYTE		*pxl3 = NULL;
	Color		clr_bfr;		// NbNW̐F
	
	if(bpp != 24 && bpp != 32){
		MessageBox(GetFocus(),"tH[}bgΉĂ܂","",MB_OK);
		return st;
	}
	
	st = Bmp->GetPixel(pos.X, pos.Y, &clr_bfr);
	if(st != Ok){
		MessageBox(GetFocus(),"F擾ł܂","",MB_OK);
		return st;
	}
	
	if(clr_bfr.GetValue() == clr_aft.GetValue()){
		return st;
	}
	
	FREE(g_pt_stack);
	g_pt_stack = (LPPOINT) malloc(1024*sizeof(POINT));
	
	// Bmpǂݍݐprbg}bv̈ƂăbN
	st = Bmp->LockBits(&rect, ImageLockModeRead, Bmp->GetPixelFormat(), &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL,*pxl2 = NULL;
		UINT	stride1;	// 4byteE
		BYTE	a,r,g,b;
		int 	x,y,y2,ab1,ab2;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		pxl2 = new BYTE [wdh*hgt*4];
		ZeroMemory(pxl2, wdh*hgt*4);
		pxl3 = new BYTE [wdh*hgt];
		ZeroMemory(pxl3, wdh*hgt);
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				if(bitmapData.Stride < 0)
					y2 = hgt - y - 1;
				else
					y2 = y;
				ab1 = stride1*y2+x*bpp/8;
				ab2 = wdh*4*y+x*4;
				pxl2[ab2+0] = pxl1[ab1+0];
				pxl2[ab2+1] = pxl1[ab1+1];
				pxl2[ab2+2] = pxl1[ab1+2];
				if(bpp == 32)
					pxl2[ab2+3] = pxl1[ab1+3];
				else
					pxl2[ab2+3] = 255;
			}
		}
		
		if(bpp == 32)
			a = clr_bfr.GetAlpha();
		else
			a = 255;
		r = clr_bfr.GetRed();
		g = clr_bfr.GetGreen();
		b = clr_bfr.GetBlue();
		
		g_num_stack = 0;
		g_pt_stack[g_num_stack].x = pos.X;
		g_pt_stack[g_num_stack].y = pos.Y;
		
		if(!Bucket32_Sub(pxl2, pxl3, wdh, hgt, a, r, g, b, da, dr, dg, db)){
			SAFE_DELETE_ARRAY(pxl2);
			SAFE_DELETE_ARRAY(pxl3);
			Bmp->UnlockBits(&bitmapData);
			FREE(g_pt_stack);
			MessageBox(GetFocus(),"sĂ܂","",MB_OK);
			return OutOfMemory;
		}
		
		FREE(g_pt_stack);
		SAFE_DELETE_ARRAY(pxl2);
		
		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl3);
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		SAFE_DELETE_ARRAY(pxl3);
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	
	FREE(g_pt_stack);
	
	// Bmpݐprbg}bv̈ƂăbN
	st = Bmp->LockBits(&rect, ImageLockModeWrite, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride2;	// 4byteE
		int 	x,y,y2,ab;
		BYTE	a,r,g,b;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride2 = abs(bitmapData.Stride);
		
		a = clr_aft.GetA();
		r = clr_aft.GetR();
		g = clr_aft.GetG();
		b = clr_aft.GetB();
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				if(bitmapData.Stride < 0)
					y2 = hgt - y - 1;
				else
					y2 = y;
				ab = stride2*y2+x*bpp/8;
				if(pxl3[wdh*y+x]){
					switch (bpp)
					{
					case 32:
						pxl1[ab+0] = b;
						pxl1[ab+1] = g;
						pxl1[ab+2] = r;
						pxl1[ab+3] = a;
						break;
					case 24:
						pxl1[ab+0] = b;
						pxl1[ab+1] = g;
						pxl1[ab+2] = r;
					}
				}
			}
		}
		
		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl3);
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		SAFE_DELETE_ARRAY(pxl3);
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	SAFE_DELETE_ARRAY(pxl3);
	return st;
}// Bucket32

// hԂ͈͂߂
bool Bucket32_Sub(BYTE *pxl2, BYTE *pxl3, int wdh, int hgt, BYTE a, BYTE r, BYTE g, BYTE b, int da, int dr, int dg, int db)
{
	// pxl3́Ah肱ݑΏۂ̍WɃtO𗧂Ă}XN
	// flagĆAFłꍇTRUEɂtO
	// flag1,flag2 ́AP̃sNZh荞ݑΏۂł͂Ȃꍇ
	// JgsNZh荞ݑΏۂ̏ꍇɂ́AX^bNɃJgWςނ߂̃tO
	// flag3 ́AX^bNɕWς񂾂ǂ̃tO
	bool	flag1,flag2,flag3,flagC;
	int 	x,ab;
	int 	xPos,yPos;
	POINT	pt;
	
	while(g_num_stack >= 0){
		flag3 = 1;
		while (flag3){
			xPos = g_pt_stack[g_num_stack].x;
			yPos = g_pt_stack[g_num_stack].y;
			pt = Bucket32_Sub_x(pxl2, pxl3, wdh, hgt, xPos, yPos, a, r, g, b, da, dr, dg, db);
			flag1 = 0;
			flag2 = 0;
			flag3 = 0;
			for(x=pt.x; x<=pt.y; x++){
				// 
				if(yPos > 0){
					ab = wdh*4*(yPos-1)+x*4;
					flagC = Compare_Argb(pxl2[ab+3], pxl2[ab+2], pxl2[ab+1], pxl2[ab+0], a, r, g, b, da, dr, dg, db);
					if( pxl3[wdh*(yPos-1)+x] || !flagC ){
						flag1 = 0;
					}
					else if( !pxl3[wdh*(yPos-1)+x] && !flag1 && flagC ){
						g_pt_stack[g_num_stack].x = x;
						g_pt_stack[g_num_stack].y = yPos-1;
						g_num_stack ++;
						if(!Check_StackSize())
							return 0;
						flag1 = 1;
						flag3 = 1;
					}
				}
				// 
				if(yPos < hgt - 1){
					ab = wdh*4*(yPos+1)+x*4;
					flagC = Compare_Argb(pxl2[ab+3], pxl2[ab+2], pxl2[ab+1], pxl2[ab+0], a, r, g, b, da, dr, dg, db);
					if( pxl3[wdh*(yPos+1)+x] || !flagC ){
						flag2 = 0;
					}
					else if( !pxl3[wdh*(yPos+1)+x] && !flag2 && flagC ){
						g_pt_stack[g_num_stack].x = x;
						g_pt_stack[g_num_stack].y = yPos+1;
						g_num_stack ++;
						if(!Check_StackSize())
							return 0;
						flag2 = 1;
						flag3 = 1;
					}
				}
			}
			g_num_stack --;
			if(g_num_stack < 0) break;
		}
	}
	return 1;
}// Bucket32_Sub

// _(xPos, yPos)̉RGB(r,g,b)FŘAsNZʒu߂
POINT Bucket32_Sub_x(BYTE *pxl2, BYTE *pxl3, int wdh, int hgt, int xPos, int yPos, BYTE a, BYTE r, BYTE g, BYTE b, int da, int dr, int dg, int db)
{
	int 	x,ab;
	bool	flag;
	POINT	pt;
	
	// _(xPos, yPos)̍𒲂ׂ
	x = 0;
	while (xPos >= x){
		ab = wdh*4*yPos+(xPos-x)*4;
		flag = Compare_Argb(pxl2[ab+3], pxl2[ab+2], pxl2[ab+1], pxl2[ab+0], a, r, g, b, da, dr, dg, db);
		if(flag)
			pxl3[wdh*yPos+xPos-x] = 1;
		else
			break;
		x ++;
	}
	pt.x = xPos - (x - 1);
	
	// _(xPos, yPos)̉E𒲂ׂ
	x = 1;
	while (x < (wdh - xPos)){
		ab = wdh*4*yPos+(xPos+x)*4;
		flag = Compare_Argb(pxl2[ab+3], pxl2[ab+2], pxl2[ab+1], pxl2[ab+0], a, r, g, b, da, dr, dg, db);
		if(flag)
			pxl3[wdh*yPos+xPos+x] = 1;
		else
			break;
		x ++;
	}
	pt.y = xPos + (x - 1);
	
	return pt;
}// Bucket32_Sub_x

// }WbNh
// (Oϐ g_mgc1 ɍWf[^)
// path   : [IN][OUT] ̃pXɗ֊sWǉ
// pos	  : [IN]	  NbNꂽsNZʒu
Status Magic_Wand(Bitmap *Bmp, GraphicsPath *path, Point pos, 
					int da, int dr, int dg, int db, bool flag_reverse)
{
	Status		st = GenericError;
	
	if(!Bmp || !path){
		MessageBox(GetFocus(),"摜A܂̓pX܂","",MB_OK);
		return st;
	}
	
	BitmapData	bitmapData;
	int 		wdh  = Bmp->GetWidth() + 2;
	int 		hgt  = Bmp->GetHeight() + 2;
	PixelFormat pfmt = PixelFormat32bppARGB;
	Rect		rect(0, 0, wdh, hgt);
	Color		clr_bfr;		// NbNW̐F
	
	st = Bmp->GetPixel(pos.X, pos.Y, &clr_bfr);
	if(st != Ok){
		MessageBox(GetFocus(),"F擾ł܂","",MB_OK);
		return st;
	}
	
	if(clr_bfr.GetA() < 255){
		dr = dg = db = 255;
	}
	
	Bitmap Bmp2(wdh, hgt, pfmt);
	Bmp2.SetResolution(Bmp->GetHorizontalResolution(), 
						Bmp->GetVerticalResolution());	// 𑜓x̐ݒ
	Graphics gBmp(&Bmp2);
	gBmp.DrawRectangle(&Pen(clr_bfr, 1), 0, 0, wdh - 1, hgt - 1);
	gBmp.DrawImage(Bmp, 1, 1);	// EƉ 1 px 炷
	
	// Bmp2ǂݍݐprbg}bv̈ƂăbN
	st = Bmp2.LockBits(&rect, ImageLockModeRead, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL,*pxl2 = NULL,*pxl3 = NULL;
		UINT	stride1;	// 4byteE
		BYTE	a,r,g,b;
		int 	x,y,ab1,ab2;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		pxl2 = new BYTE [wdh*hgt*4];
		ZeroMemory(pxl2, wdh*hgt*4);
		pxl3 = new BYTE [wdh*hgt];
		ZeroMemory(pxl3, wdh*hgt);
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				ab1 = stride1*y+x*4;
				ab2 = wdh*4*y+x*4;
				pxl2[ab2+0] = pxl1[ab1+0];
				pxl2[ab2+1] = pxl1[ab1+1];
				pxl2[ab2+2] = pxl1[ab1+2];
				pxl2[ab2+3] = pxl1[ab1+3];
			}
		}
		
		a = clr_bfr.GetAlpha();
		r = clr_bfr.GetRed();
		g = clr_bfr.GetGreen();
		b = clr_bfr.GetBlue();
		
		FREE(g_pt_stack);
		g_pt_stack = (LPPOINT) malloc(1024*sizeof(POINT));
		g_num_stack = 0;
		g_pt_stack[g_num_stack].x = pos.X + 1;	// ŏɂ炵A+1 
		g_pt_stack[g_num_stack].y = pos.Y + 1;
		
		if(!Bucket32_Sub(pxl2, pxl3, wdh, hgt, a, r, g, b, da, dr, dg, db)){
			SAFE_DELETE_ARRAY(pxl2);
			SAFE_DELETE_ARRAY(pxl3);
			Bmp2.UnlockBits(&bitmapData);
			FREE(g_pt_stack);
			MessageBox(GetFocus(),"sĂ܂","",MB_OK);
			return OutOfMemory;
		}
		
		SAFE_DELETE_ARRAY(pxl2);
		FREE(g_pt_stack);
		
		// }XN𔽓]
		
		if(flag_reverse){
			for(y=0;y<hgt;y++){
				for(x=0;x<wdh;x++){
					ab1 = wdh*y+x;
					if(pxl3[ab1])
						pxl3[ab1] = 0;
					else
						pxl3[ab1] = 1;
				}
			}
		}
		
		// ̗̈֊s pxl3 ɐݒ
		
		int 	i,x2,y2;
		
		for(y=1;y<hgt-1;y++){
			for(x=1;x<wdh-1;x++){
				ab1 = wdh*y+x;
				if(pxl3[ab1]){
					for(i=0;i<4;i++){
						x2 = x + g_pt2[i].x;
						y2 = y + g_pt2[i].y;
						if(Get_FlagPixel(pxl3, wdh, hgt, x2, y2) == 0){
							pxl3[ab1] = 2;	// ֊s_ 2 ɂ
							break;
						}
					}
				}
			}
		}
		
		// ֊s̍Wя g_mgc1 ɐݒ
		
		Point	pos_first;
		
		pos_first = Search_FirstPt(pxl3, wdh, hgt, pos.X + 1, pos.Y + 1);
		
		if(pos_first.X >= 0 && pos_first.Y >= 0){
			g_mgc1.num = 0;
			FREE(g_mgc1.pt);
			int mem_size = 1024 * sizeof(Point);
			g_mgc1.pt = (Point*) malloc(mem_size);
			g_slant_pre = -1;	// ŏ͌X
			if(Check_MagicMemorySize()){
				Search_NextPt(pxl3, wdh, hgt, pos_first.X, pos_first.Y);
			}
			if(g_mgc1.num > 0){
				path->StartFigure();
				path->AddLines(g_mgc1.pt, g_mgc1.num);
				path->CloseFigure();
			}
		}
		
		FREE(g_mgc1.pt);
		SAFE_DELETE_ARRAY(pxl3);
		
		st = Bmp2.UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	
	return st;
}// Magic_Wand

// ֊s̍ŏ̓_Ti}WbNhpj
Point Search_FirstPt(BYTE *pxl, int wdh, int hgt, int x, int y)
{
	Point	pt2(-1,-1);
	int 	i,x2[8],y2[8];
	
	bool	flag_loop_out = false;
	
	for(i=0;i<8;i++){
		x2[i] = x;
		y2[i] = y;
	}
	
	do{
		for(i=0;i<8;i++){
			x2[i] += g_pt1[i].x;
			y2[i] += g_pt1[i].y;
			if(x2[i] >= 1 && y2[i] >= 1 && x2[i] < wdh -1 && y2[i] < hgt - 1){
				if(Get_FlagPixel(pxl, wdh, hgt, x2[i], y2[i]) == 2){
					flag_loop_out = true;	// I
					pt2.X = x2[i];
					pt2.Y = y2[i];
					break;
				}
			}
			else{
				if( i == 0 && y2[i] >= hgt - 1 || 
					i == 1 && x2[i] < 1 && y2[i] >= hgt - 1 || 
					i == 2 && x2[i] < 1 || 
					i == 3 && x2[i] < 1 && y2[i] < 1 || 
					i == 4 && y2[i] < 1 || 
					i == 5 && x2[i] >= wdh -1 && y2[i] < 1 || 
					i == 6 && x2[i] >= wdh -1 || 
					i == 7 && x2[i] >= wdh -1 && y2[i] >= hgt - 1)
				{
					flag_loop_out = true;	// ȂI
					break;
				}
			}
		}
	}while(!flag_loop_out);
	
	return pt2;
}// Search_FirstPt
/*
// ֊s̎̓_Ti}WbNhpj
// sSAoO
void Search_NextPt(BYTE *pxl, int wdh, int hgt, int x, int y)
{
	int i,x2,y2,x3,y3;
	
	for(i=0;i<8;i++){
		x2 = x + g_pt1[i].x;
		y2 = y + g_pt1[i].y;
		x3 = x + g_pt1[i+1].x;
		y3 = y + g_pt1[i+1].y;
		
		bool	flag2 = false;	// ̈敝 1 Ŏ΂߂ɗאڂsNZ͖tO
		BYTE	val1[4];
		val1[0] = Get_FlagPixel(pxl, wdh, hgt, x, y+1);
		val1[1] = Get_FlagPixel(pxl, wdh, hgt, x-1, y);
		val1[2] = Get_FlagPixel(pxl, wdh, hgt, x, y-1);
		val1[3] = Get_FlagPixel(pxl, wdh, hgt, x+1, y);
		
		if( i == 1 && val1[0] == 0 && val1[1] == 0 || 
			i == 3 && val1[1] == 0 && val1[2] == 0 || 
			i == 5 && val1[2] == 0 && val1[3] == 0 || 
			i == 7 && val1[3] == 0 && val1[0] == 0)
		{
			flag2 = true;
		}
		
		if(!flag2 && pxl[wdh*y2+x2] == 2 &&  pxl[wdh*y3+x3] == 0){
			g_mgc1.pt[g_mgc1.num].X = x - 1;   // ŏɂ炵A-1 
			g_mgc1.pt[g_mgc1.num].Y = y - 1;
			Set_SafePos(&g_mgc1.pt[g_mgc1.num], wdh-3, hgt-3);
			g_mgc1.num ++;
			pxl[wdh*y2+x2] = 1; 	// W g_mgc1 ɓꂽ֊s_͏
			if(Check_MagicMemorySize()){
				Search_NextPt(pxl, wdh, hgt, x2, y2);
			}
			break;
		}
	}
}// Search_NextPt
*/
// ֊s̎̓_Ti}WbNhpj
// i֊sPő܏HꍇɂΉAXłꍇ́A
// Ԉ悤ɂ̂A摜TCY傫ꍇ́AĨoOLBċA[Ȃ߂̂Hj
void Search_NextPt(BYTE *pxl, int wdh, int hgt, int x, int y)
{
	int 	i,j,x2,y2,x3,y3;
	bool	flag1 = false;	// l 2 ̃sNZאڂĂ΁Atrue
	
	for(i=0;i<8;i++){
		x2 = x + g_pt1[i].x;
		y2 = y + g_pt1[i].y;
		x3 = x + g_pt1[i+1].x;
		y3 = y + g_pt1[i+1].y;
		
		bool	flag2 = false;	// ̈敝 1 Ŏ΂߂ɗאڂsNZ͖tO
		BYTE	val1[4];
		val1[0] = Get_FlagPixel(pxl, wdh, hgt, x, y+1);
		val1[1] = Get_FlagPixel(pxl, wdh, hgt, x-1, y);
		val1[2] = Get_FlagPixel(pxl, wdh, hgt, x, y-1);
		val1[3] = Get_FlagPixel(pxl, wdh, hgt, x+1, y);
		
		if( i == 1 && val1[0] == 0 && val1[1] == 0 || 
			i == 3 && val1[1] == 0 && val1[2] == 0 || 
			i == 5 && val1[2] == 0 && val1[3] == 0 || 
			i == 7 && val1[3] == 0 && val1[0] == 0)
		{
			flag2 = true;
		}
		
		if(!flag2 && Get_FlagPixel(pxl, wdh, hgt, x2, y2) == 2 &&  Get_FlagPixel(pxl, wdh, hgt, x3, y3) == 0){
			flag1 = true;
			if(g_slant_pre < 0 || i != g_slant_pre){
				g_mgc1.pt[g_mgc1.num].X = x - 1;	// ŏɂ炵A-1 
				g_mgc1.pt[g_mgc1.num].Y = y - 1;
				Set_SafePos(&g_mgc1.pt[g_mgc1.num], wdh-3, hgt-3);
				g_slant_pre = i;	// Xێ
				g_mgc1.num ++;
			}
			BYTE	val2[4];
			for(j=0;j<4;j++){
				val2[j] = Get_FlagPixel(pxl, wdh, hgt, x2 + g_pt2[j].x, y2 + g_pt2[j].y);
			}
			if( (val2[0] > 0 && val2[2] > 0 && val2[1] == 0 && val2[3] == 0) || 
				(val2[0] == 0 && val2[2] == 0 && val2[1] > 0 && val2[3] > 0))
			{
				pxl[wdh*y2+x2] = 3; // ֊s_͏ï敝 1 ̑܏H 3j
			}
			else{
				pxl[wdh*y2+x2] = 1; // ֊s_͏
			}
			if(Check_MagicMemorySize()){
				Search_NextPt(pxl, wdh, hgt, x2, y2);
			}
			break;
		}
	}
	if(!flag1){
		for(i=0;i<8;i++){
			x2 = x + g_pt1[i].x;
			y2 = y + g_pt1[i].y;
			if(Get_FlagPixel(pxl, wdh, hgt, x2, y2) == 3){
				if(g_slant_pre < 0 || i != g_slant_pre){
					g_mgc1.pt[g_mgc1.num].X = x - 1;	// ŏɂ炵A-1 
					g_mgc1.pt[g_mgc1.num].Y = y - 1;
					Set_SafePos(&g_mgc1.pt[g_mgc1.num], wdh-3, hgt-3);
					g_slant_pre = i;	// Xێ
					g_mgc1.num ++;
				}
				pxl[wdh*y2+x2] = 1; // ֊s_͏
				if(Check_MagicMemorySize()){
					Search_NextPt(pxl, wdh, hgt, x2, y2);
				}
				break;
			}
		}
	}
}// Search_NextPt

// Ï̕`
Status Draw_ArrowPath(Graphics *g, GraphicsPath *path, int wdh, int hgt, int dx, int dy, 
						FillMode fillmode, int zoom, Pen *pen_w, Pen *pen_b)
{
	Status		st = GenericError;
	
	if(!g || !path || !pen_w || !pen_b){
		return st;
	}
	
	if(zoom >= 200){
		PixelFormat pfmt = PixelFormat24bppRGB;
		Bitmap		Bmp(wdh, hgt, pfmt);
		Graphics	gBmp(&Bmp);
		Rect		rcBmp(0, 0, wdh, hgt);
		st = path->SetFillMode(fillmode);
		st = gBmp.SetClip(rcBmp);
		st = gBmp.FillPath(&SolidBrush(Color(255, 0, 0)), path);
		st = gBmp.DrawPath(&Pen(Color(255, 255, 0), 1), path);
		
		Rect rcDot;
		path->GetBounds(&rcDot);
		
		GraphicsPath path3(FillModeAlternate);
		
		Draw_ZoomPath(&Bmp, pfmt, &path3, rcDot, dx, dy, zoom);
		
		st = g->DrawPath(pen_w, &path3);
		st = g->DrawPath(pen_b, &path3);
	}
	else{
		GraphicsPath *path2 = path->Clone();
		Matrix mx((float)zoom / 100, 0, 0, (float)zoom / 100, (float)dx, (float)dy);
		path2->Transform(&mx);
		g->DrawPath(pen_w, path2);
		g->DrawPath(pen_b, path2);
		SAFE_DELETE_OBJ(path2);
	}
	return st;
}//  Draw_ArrowPath

// y̑̕`
Status Draw_PenThick(Graphics *g, GraphicsPath *path, Bitmap *BmpDot, Point pos, 
					 int wdh, int hgt, int dx, int dy, int zoom, Pen *pen1, Pen *pen2)
{
	Status		st = GenericError;
	
	if(!g || !path || !BmpDot || !pen1 || !pen2){
		return st;
	}
	
	if(pos.X < 0 || pos.Y < 0 || pos.X >= wdh || pos.Y >= hgt){
		return st;
	}
	
	int wdhDot = BmpDot->GetWidth();
	int hgtDot = BmpDot->GetHeight();
	int xDot = pos.X - wdhDot / 2;
	int yDot = pos.Y - hgtDot / 2;
	
	if(zoom >= 200){
		PixelFormat pfmt = PixelFormat24bppRGB;
		Bitmap		Bmp(wdh, hgt, pfmt);
		Graphics	gBmp(&Bmp);
		Rect		rcBmp(0, 0, wdh, hgt);
		st = gBmp.SetClip(rcBmp);
		
		gBmp.DrawImage(BmpDot, xDot, yDot);
		
		Rect rcDot(xDot, yDot, wdhDot, hgtDot);
		
		GraphicsPath path3(FillModeAlternate);
		
		Draw_ZoomPath(&Bmp, pfmt, &path3, rcDot, dx, dy, zoom);
		
		st = g->DrawPath(pen1, &path3);
		st = g->DrawPath(pen2, &path3);
	}
	else{
		GraphicsPath *path2 = path->Clone();
		Matrix mx((float)zoom / 100, 0, 0, (float)zoom / 100, 
				(float)dx + (float) xDot * (float)zoom / 100, 
				(float)dy + (float) yDot * (float)zoom / 100);
		path2->Transform(&mx);
		g->DrawPath(pen1, path2);
		g->DrawPath(pen2, path2);
		SAFE_DELETE_OBJ(path2);
	}
	return st;
}//  Draw_PenThick

// \{ 200% ȏ̏ꍇ̃pX̕`
Status Draw_ZoomPath(Bitmap *Bmp, PixelFormat pfmt, GraphicsPath *path, Rect rcDot, 
					 int dx, int dy, int zoom)
{
	Status		st = GenericError;
	
	if(!Bmp || !path){
		return st;
	}
	
	if(PixelFormat24bppRGB != Bmp->GetPixelFormat()){
		return st;
	}
	
	int wdh  = Bmp->GetWidth();
	int hgt  = Bmp->GetHeight();
	
	Rect rcBmp(0, 0, wdh, hgt);
	
	BitmapData	bitmapData;
	
	// Bmpǂݍݐprbg}bv̈ƂăbN
	st = Bmp->LockBits(&rcBmp, ImageLockModeRead, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride1;	// 4byteE
		int 	x,y;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		const POINT pt1[4] = {{0,1},{-1,0},{0,-1},{1,0}};	// 4ߖT̔z
		int 		i,x1,y1,x2,y2;
		int 		len = zoom / 100;
		
		for(y=rcDot.Y;y<rcDot.Y+rcDot.Height;y++){
			for(x=rcDot.X;x<rcDot.X+rcDot.Width;x++){
				int xZoom = x * len + dx;
				int yZoom = y * len + dy;
				if(Get_FlagPixel(pxl1, stride1, wdh, hgt, x, y, 1)){	// 1 ́ADraw_ArrowPath() p
					for(i=0;i<4;i++){
						if(0 == Get_FlagPixel(pxl1, stride1, wdh, hgt, 
										x+pt1[i].x, y+pt1[i].y, 2)) 	// 2 ́ADraw_ArrowPath() p
						{
							switch (i)
							{
							case 0:
								x1 = xZoom;
								y1 = yZoom + len;
								x2 = xZoom + len;
								y2 = yZoom + len;
								break;
							case 1:
								x1 = xZoom;
								y1 = yZoom;
								x2 = xZoom;
								y2 = yZoom + len;
								break;
							case 2:
								x1 = xZoom;
								y1 = yZoom;
								x2 = xZoom + len;
								y2 = yZoom;
								break;
							case 3:
								x1 = xZoom + len;
								y1 = yZoom;
								x2 = xZoom + len;
								y2 = yZoom + len;
								break;
							}
							st = path->StartFigure();
							st = path->AddLine(x1, y1, x2, y2);
						}
					}
				}
			}
		}
		
		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	return st;
}// Draw_ZoomPath

// 摜Ɏ܂Wɐݒ
void Set_SafePos(Point *pt, int wdh, int hgt)
{
	if(pt->X < 0)	pt->X = 0;
	if(pt->X > wdh) pt->X = wdh;
	if(pt->Y < 0)	pt->Y = 0;
	if(pt->Y > hgt) pt->Y = hgt;
}// Set_SafePos

// wW̃tOԂiÏ`pj
BYTE Get_FlagPixel(BYTE *pxl, UINT stride, int wdh, int hgt, int x, int y, int rgb)
{
	if(x < 0 || x >= wdh || y < 0 || y >= hgt)
		return 0;
	return pxl[stride * y + x * 3 + rgb];
}// Get_FlagPixel

// wW̃tOԂi}WbNhpj
BYTE Get_FlagPixel(BYTE *pxl, int wdh, int hgt, int x, int y)
{
	if(x < 0 || x >= wdh || y < 0 || y >= hgt)
		return 0;
	return pxl[wdh * y + x];
}// Get_FlagPixel

// h荞ݔ͈͂̔
bool Compare_Argb(BYTE a1, BYTE r1, BYTE g1, BYTE b1, BYTE a2, BYTE r2, BYTE g2, BYTE b2, int da, int dr, int dg, int db)
{
	bool flag = 0;
	int a_min,r_min,g_min,b_min,a_max,r_max,g_max,b_max;
	a_min = a2 - da;
	if(a_min < 0)	a_min = 0;
	r_min = r2 - dr;
	if(r_min < 0)	r_min = 0;
	g_min = g2 - dg;
	if(g_min < 0)	g_min = 0;
	b_min = b2 - db;
	if(b_min < 0)	b_min = 0;
	a_max = a2 + da;
	if(a_max > 255) a_max = 255;
	r_max = r2 + dr;
	if(r_max > 255) r_max = 255;
	g_max = g2 + dg;
	if(g_max > 255) g_max = 255;
	b_max = b2 + db;
	if(b_max > 255) b_max = 255;
	if((a1 >= (BYTE)a_min && a1 <= (BYTE)a_max) &&
	  (r1 >= (BYTE)r_min && r1 <= (BYTE)r_max) &&
	  (g1 >= (BYTE)g_min && g1 <= (BYTE)g_max) &&
	  (b1 >= (BYTE)b_min && b1 <= (BYTE)b_max))
	{
		flag = 1;
	}
	return flag;
}// Compare_Argb

// X^bNg؂AX^bNTCY𑝂₷
bool Check_StackSize()
{
	size_t size = _msize(g_pt_stack);
	if(g_num_stack * sizeof(POINT) >= size){
		g_pt_stack = (POINT*)realloc(g_pt_stack, size+512*sizeof(POINT));
		if(!g_pt_stack){
			return 0;
		}
	}
	return 1;
}// Check_StackSize

// }WbNh̃[g؂ATCY𑝂₷
bool Check_MagicMemorySize()
{
	size_t size = _msize(g_mgc1.pt);
	if(g_mgc1.num * sizeof(POINT) >= size){
		g_mgc1.pt = (Point*)realloc(g_mgc1.pt, size+512*sizeof(Point));
		if(!g_mgc1.pt){
			return 0;
		}
	}
	return 1;
}// Check_MagicMemorySize
