typedef struct{
	Bitmap *Bmp;				// Nbv{[hpO[oBitmapIuWFNg
	GraphicsPath	*path;		// Nbv{[hpO[oPathIuWFNg
	BYTE			*mask;		// Nbv{[hpO[oF}XNf[^
}CLPBRD,*LPCLPBRD;

typedef struct{
	BITMAPINFO		*pbmi;
	BYTE			*pbits;
	int				pbmi_sz;
	int				pbits_sz;
}DIB,*LPDIB;

DIB		g_Dib = {NULL,NULL,0,0};
CLPBRD	ClpBrd = {NULL,NULL,NULL};

Status	Get_ClipBoard();
Status	Get_ClipBoard_DIB();
Status	DibToBmp(LPBITMAPINFO pbmi, LPBYTE pbits);
Status	Get_ClipBoard_DDB();
Status	Get_Hpal(ColorPalette *ppal);
void	Set_ClipBoard(HWND hWnd, Bitmap *Bmp_R);
Status	Set_ClipBoard_DDB(HWND hWnd, Bitmap *Bmp_R);
Status	Set_ClipBoard_DIB(Bitmap *Bmp_R);
Status	BmpToDib(Bitmap *Bmp_R);
Status	Set_ClipBoard_Pal(Bitmap *Bmp_R);
void	Set_ClipBoard_Path(PathData *pd, FillMode mode);
void	Set_ClipBoard_Alpha(BYTE *mask, int mask_size);
bool	Get_ClipBoard2();
Status	Get_PathMask(GraphicsPath *path, BYTE *mask, Rect rc);
Status	Set_PathMask(Bitmap *Bmp, BYTE *mask);
Status	Get_AlphaMask(Bitmap *Bmp, BYTE *mask, Rect rc);


// Nbv{[hrbg}bvǂݍ
Status Get_ClipBoard()
{
	Status		st = GenericError;
	int			fmt;
	UINT		fmt_list[] = {CF_DIB,CF_BITMAP};
	
	fmt = GetPriorityClipboardFormat(fmt_list,sizeof(fmt_list)/sizeof(UINT));
	if(fmt <= 0){
		MessageBox(GetFocus(),"Nbv{[h͋łB","Clipboard Error",MB_OK | MB_ICONWARNING);
		return st;
	}
	
	if(!OpenClipboard(NULL)){
		MessageBox(GetFocus(),"Nbv{[hJ܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		return st;
	}
	
	if(fmt == CF_DIB){
		st = Get_ClipBoard_DIB();
		if(st != Ok){
			st = Get_ClipBoard_DDB();
		}
	}
	else if(fmt == CF_BITMAP){
		st = Get_ClipBoard_DDB();
	}
	else{
		return st;
	}
	
	if(!CloseClipboard()){
		MessageBox(GetFocus(),"Nbv{[h܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		return st;
	}
	return Ok;
}// Get_ClipBoard

// Nbv{[hDIBǂݍ݁AClpBrd.Bmpɓ
Status Get_ClipBoard_DIB()
{
	Status			st = GenericError;
	HANDLE			hMem;
	BITMAPINFO		*pbmi = NULL;
	BYTE			*pbits = NULL; 	// sNZf[^
	
	hMem = (HANDLE) GetClipboardData (CF_DIB);
	if(!hMem)	return st;
	pbmi = (LPBITMAPINFO) GlobalLock (hMem);
	if(!pbmi){
		MessageBox(GetFocus(),"Nbv{[hbNł܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		GlobalUnlock(hMem);
		return st;
	}
	
	pbits = (LPBYTE)pbmi + BmiSize(&(pbmi->bmiHeader));
	
	st = DibToBmp(pbmi, pbits);
	
	GlobalUnlock(hMem);
	
	return st;
}// Get_ClipBoard_DIB

// DIB  ClpBrd.Bmp 쐬
Status DibToBmp(LPBITMAPINFO pbmi, LPBYTE pbits)
{
	Status	st = GenericError;
	
	if(!pbmi || !pbits){
		return st;
	}
	
	Bitmap Bmp1 (pbmi, pbits);
	
	int 		wdh	= Bmp1.GetWidth();
	int 		hgt	= Bmp1.GetHeight();
	PixelFormat fmt	= Bmp1.GetPixelFormat();
	
	SAFE_DELETE_OBJ(ClpBrd.Bmp);
	
	ClpBrd.Bmp = new Bitmap (wdh, hgt, fmt);
	
	st = ClpBrd.Bmp->GetLastStatus();
	if(st != Ok){
		SAFE_DELETE_OBJ(ClpBrd.Bmp);
		return st;
	}
	
	// pbg
	if(fmt & PixelFormatIndexed){
		ColorPalette	*ppal = NULL;
		int 			p_sz = Bmp1.GetPaletteSize();
		ppal = (ColorPalette *) new BYTE [p_sz];
		if(ppal){
			st = Bmp1.GetPalette(ppal, p_sz);
			if(st == Ok){
				st = ClpBrd.Bmp->SetPalette(ppal);
			}
		}
		SAFE_DELETE_ARRAY_BYTE(ppal);
	}
	
	// sNZl̃Rs[
	if(_winmajor >= 6 && !(fmt & PixelFormatIndexed) && (fmt != PixelFormat32bppRGB)){
		Graphics	gBmp(ClpBrd.Bmp);
		gBmp.DrawImage(&Bmp1, 0, 0, wdh, hgt);
	}
	else{
		BitmapData	bitmapData;
		int 		bpp		= pbmi->bmiHeader.biBitCount;
		Rect		rect(0, 0, wdh, hgt);
		st = ClpBrd.Bmp->LockBits(&rect, ImageLockModeWrite, fmt, &bitmapData);
		if (st == Ok)
		{
			int y,y2;
			
			LPBYTE pixels = (LPBYTE) bitmapData.Scan0;
			
			int stride = abs(bitmapData.Stride);
			
			if(bpp <= 0 || bpp > 32){
				ZeroMemory(pixels, stride * hgt);
			}
			else{
				for(y=0;y<hgt;y++){
					if(pbmi->bmiHeader.biHeight >= 0){
						y2 = hgt - y - 1;
					}
					else{
						y2 = y;
					}
					if(bpp >= 8){
						memcpy(&pixels[y2 * stride], &pbits[y * stride], wdh * (bpp / 8));
					}
					else{
						memcpy(&pixels[y2 * stride], &pbits[y * stride], wdh / (8 / bpp));
					}
				}
			}
			st = ClpBrd.Bmp->UnlockBits(&bitmapData);
		}
		if(st != Ok){
			MessageBox(GetFocus(),"Bmp2 Lock or Unlock Error","Clipboard Error",MB_OK);
			SAFE_DELETE_OBJ(ClpBrd.Bmp);
			return st;
		}
	}
	return st;
}// DibToBmp

// Nbv{[hDDBǂݍ݁AClpBrd.Bmpɓ
// fmt_destFo̓tH[}bgBNbv{[hf[^̃tH[}bggp̏ꍇNULLB
Status Get_ClipBoard_DDB()
{
	Status		st = GenericError;
	HBITMAP		hBmp;
	HPALETTE	hPal;
	
	SAFE_DELETE_OBJ(ClpBrd.Bmp);
	hBmp = (HBITMAP) GetClipboardData(CF_BITMAP);
	if(!hBmp){
		MessageBox(GetFocus(),"hBmp̓ǂݍ݂Ɏs܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		return st;
	}
	hPal = (HPALETTE) GetClipboardData(CF_PALETTE);	// L̓foCXɈ˂
	
	if(hBmp){
		ClpBrd.Bmp = new Bitmap (hBmp, hPal);
		st = ClpBrd.Bmp->GetLastStatus();
		if(st != Ok){
			MessageBox(GetFocus(),"ClpBrd.Bmp쐬ł܂2","Clipboard Error",MB_OK | MB_ICONWARNING);
			SAFE_DELETE_OBJ(ClpBrd.Bmp);
			return st;
		}
	}
	return Ok;
}// Get_ClipBoard_DDB

// Get_ClipBoard_DIB֐HPALETTEKpꍇ
Status Get_Hpal(ColorPalette *ppal)
{
	HPALETTE	hPal;
	UINT		nColors = 0;
	UINT		p_sz = 0;
	PALETTEENTRY pe[256];
	hPal = (HPALETTE) GetClipboardData(CF_PALETTE);
	GetObject(hPal, sizeof(int), &nColors);
	p_sz = sizeof(ColorPalette)+sizeof(ARGB)*(nColors-1);
	GetPaletteEntries(hPal, 0, nColors, pe);
	ppal = (ColorPalette *)new BYTE[p_sz];
	if (ppal == NULL){
		SAFE_DELETE_ARRAY_BYTE(ppal);
		MessageBox(GetFocus(),"pbg̓ǂݍ݂Ɏs܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		return OutOfMemory;
	}
	ZeroMemory(ppal, p_sz);
	ppal->Flags = 0;
	ppal->Count = nColors;
	for (UINT i = 0; i < nColors; i++)
	{
		ppal->Entries[i] = Color::MakeARGB( 0xff, 
											pe[i].peRed, 
											pe[i].peGreen, 
											pe[i].peBlue );
	}
	return Ok;
}// Get_Hpal

// Nbv{[hɃrbg}bvu
void Set_ClipBoard(HWND hWnd, Bitmap *Bmp_R)
{
	if(!Bmp_R)	return;
	
	if(OpenClipboard(NULL)){
		EmptyClipboard();
		Status st = BmpToDib(Bmp_R);
		if(st == Ok){
			Set_ClipBoard_DDB(hWnd, Bmp_R);
			Set_ClipBoard_DIB(Bmp_R);
		}
		SAFE_DELETE_ARRAY(g_Dib.pbits);
		SAFE_DELETE_ARRAY_BYTE(g_Dib.pbmi);
		g_Dib.pbmi_sz = 0;
		g_Dib.pbits_sz = 0;
		if(PxFmtToBpp(Bmp_R->GetPixelFormat()) <= 8)
			Set_ClipBoard_Pal(Bmp_R);
		CloseClipboard();
	}
}// Set_ClipBoard

// Nbv{[hDDBu
Status Set_ClipBoard_DDB(HWND hWnd, Bitmap *Bmp_R)
{
	if(!Bmp_R || !g_Dib.pbmi || !g_Dib.pbits){
		return GenericError;
	}
	
	HDC hDC = GetDC(hWnd);
	HBITMAP hBmp = CreateDIBitmap(hDC, &(g_Dib.pbmi->bmiHeader), CBM_INIT,
									g_Dib.pbits, g_Dib.pbmi, DIB_RGB_COLORS);
	ReleaseDC(hWnd, hDC);
	
	if(hBmp){
		if(!SetClipboardData(CF_BITMAP, hBmp)){
			DeleteObject(hBmp);
			MessageBox(GetFocus(),"HBITMAPCOPYɎs܂","Clipboard Error",MB_OK | MB_ICONWARNING);
			return GenericError;
		}
	}
	else{
		return GenericError;
	}
	return Ok;
}// Set_ClipBoard_DDB

// Nbv{[hDIBu
Status Set_ClipBoard_DIB(Bitmap *Bmp_R)
{
	Status	st = GenericError;
	
	if(!Bmp_R || !g_Dib.pbmi || !g_Dib.pbits){
		return st;
	}
	
	if(PxFmtToBpp(Bmp_R->GetPixelFormat()) > 32){
		MessageBox(GetFocus(),"48bitFȏ̃rbg}bv́ANbv{[hɒu܂","Clipboard Error",MB_OK | MB_ICONWARNING);
		return st;
	}
	
	HANDLE	hMem = NULL;
	BYTE	*buf = NULL;
	
	hMem = GlobalAlloc(GMEM_MOVEABLE, g_Dib.pbmi_sz + g_Dib.pbits_sz);
	buf = (LPBYTE) GlobalLock(hMem);
	memcpy(buf, g_Dib.pbmi, g_Dib.pbmi_sz);
	memcpy(buf + g_Dib.pbmi_sz, g_Dib.pbits, g_Dib.pbits_sz);
	SetClipboardData(CF_DIB, hMem);
	GlobalUnlock(hMem);
	
	return Ok;
}// Set_ClipBoard_DIB

// Oϐg_DibBmp_RDIBݒ
Status BmpToDib(Bitmap *Bmp_R)
{
	if(!Bmp_R){
		return GenericError;
	}
	
	SAFE_DELETE_ARRAY(g_Dib.pbits);
	SAFE_DELETE_ARRAY_BYTE(g_Dib.pbmi);
	g_Dib.pbmi_sz = 0;
	g_Dib.pbits_sz = 0;
	
	Status			st;
	BitmapData		bitmapData;
	int 			wdh 	= Bmp_R->GetWidth();
	int 			hgt 	= Bmp_R->GetHeight();
	PixelFormat 	format	= Bmp_R->GetPixelFormat();
	int 			bpp 	= PxFmtToBpp(format);	// J[fvX
	UINT			nColors = 0;					// pbg̍őF
	UINT			nBitFields = 0;					// 16-R5G6B5 }XÑTCY
	Rect			rect(0, 0, wdh, hgt);
	
	if(bpp <= 0 || bpp > 32){
		return GenericError;
	}
	
	if(bpp <= 8)	nColors = 1 << bpp;
	
	if(format == PixelFormat16bppRGB565)
		nBitFields = sizeof(DWORD) * 3;
	
	g_Dib.pbmi_sz = sizeof(BITMAPINFOHEADER)+nBitFields+nColors*sizeof(RGBQUAD);
	
	g_Dib.pbmi = (LPBITMAPINFO) new BYTE [g_Dib.pbmi_sz];
	ZeroMemory(&g_Dib.pbmi->bmiColors, nBitFields+nColors*sizeof(RGBQUAD));
	ZeroMemory(&g_Dib.pbmi->bmiHeader, sizeof(BITMAPINFOHEADER));
	g_Dib.pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	g_Dib.pbmi->bmiHeader.biWidth = wdh;
	g_Dib.pbmi->bmiHeader.biHeight = hgt;
	g_Dib.pbmi->bmiHeader.biBitCount = bpp;
	g_Dib.pbmi->bmiHeader.biPlanes = 1;
	g_Dib.pbmi->bmiHeader.biClrUsed = 0;			// \tgƂ̌݊̂
	if(format == PixelFormat16bppRGB565)
		g_Dib.pbmi->bmiHeader.biCompression = BI_BITFIELDS;
	else
		g_Dib.pbmi->bmiHeader.biCompression = BI_RGB;
	
	if(format == PixelFormat16bppRGB565){
		DWORD mask[3] = {0xF800, 0x07E0, 0x001F};
		memcpy(&g_Dib.pbmi->bmiColors, mask, sizeof(mask));
	}
	
	// sNZirbgjl
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, format, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels = NULL;
		int 	x,y,y2;
		
		pixels = (LPBYTE) bitmapData.Scan0;
		
		int stride = abs(bitmapData.Stride);
		
		g_Dib.pbits_sz = stride * hgt * sizeof(BYTE);
		g_Dib.pbmi->bmiHeader.biSizeImage = g_Dib.pbits_sz;
		g_Dib.pbits = new BYTE [g_Dib.pbits_sz];
		
		for(y=0;y<hgt;y++){
			if(bitmapData.Stride < 0){
				y2 = y;
			}
			else{
				y2 = hgt - y - 1;
			}
			if(bpp >= 8){
				for(x=0;x<wdh*(bpp/8);x++){
					g_Dib.pbits[y*stride+x] = pixels[y2*stride+x];
				}
			}
			else{
				for(x=0;x<wdh;x++){
					g_Dib.pbits[y*stride+x/(8/bpp)] = pixels[y2*stride+x/(8/bpp)];
				}
			}
		}
		st = Bmp_R->UnlockBits(&bitmapData);
	}
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp Lock or Unlock Error","Clipboard Error",MB_OK);
		SAFE_DELETE_ARRAY(g_Dib.pbits);
		SAFE_DELETE_ARRAY_BYTE(g_Dib.pbmi);
		return st;
	}
	
	// pbg
	if(bpp <= 8){
		int p_sz = Bmp_R->GetPaletteSize();
		ColorPalette *pal = NULL;
		pal = (ColorPalette*) new BYTE [p_sz];
		st = Bmp_R->GetPalette(pal, p_sz);
		if(st == Ok){
			for(UINT i=0;i<pal->Count;i++){
				g_Dib.pbmi->bmiColors[i].rgbRed      = (BYTE) (pal->Entries[i] >> 16);
				g_Dib.pbmi->bmiColors[i].rgbGreen    = (BYTE) (pal->Entries[i] >> 8);
				g_Dib.pbmi->bmiColors[i].rgbBlue     = (BYTE)  pal->Entries[i];
				g_Dib.pbmi->bmiColors[i].rgbReserved = 0;
			}
		}
		else{
			SAFE_DELETE_ARRAY_BYTE(pal);
			SAFE_DELETE_ARRAY_BYTE(g_Dib.pbmi);
			MessageBox(GetFocus(),"pbgݒł܂","Clipboard Error",MB_OK);
			return st;
		}
		SAFE_DELETE_ARRAY_BYTE(pal);
	}
	
	return st;
}// BmpToDib

// Nbv{[hHPALETTEu
Status Set_ClipBoard_Pal(Bitmap *Bmp_R)
{
	Status			st;
	HPALETTE		hPal;
	PALETTEENTRY	pe[256] = {0};
	LOGPALETTE		*lpal = NULL;
	int				bpp = PxFmtToBpp(Bmp_R->GetPixelFormat());
	UINT			nColors = 0;			// pbg̍őF
	
	if(bpp <= 8)	nColors = 1 << bpp;
	
	int p_sz = Bmp_R->GetPaletteSize();
	ColorPalette *gpal = NULL;
	gpal = (ColorPalette*) new BYTE [p_sz];
	st = Bmp_R->GetPalette(gpal, p_sz);
	if(st == Ok){
		lpal = (LPLOGPALETTE) new BYTE [sizeof(LOGPALETTE) + (nColors-1) * sizeof(PALETTEENTRY)];
		lpal->palVersion = 0x300;
		lpal->palNumEntries = nColors;
		
		for(UINT i=0;i<gpal->Count;i++){
			lpal->palPalEntry[i].peRed		= (BYTE) (gpal->Entries[i] >> 16);
			lpal->palPalEntry[i].peGreen	= (BYTE) (gpal->Entries[i] >> 8);
			lpal->palPalEntry[i].peBlue		= (BYTE)  gpal->Entries[i];
			lpal->palPalEntry[i].peFlags	= 0;
		}
		hPal = CreatePalette(lpal);
		SAFE_DELETE_ARRAY_BYTE(lpal);
	}
	else{
		SAFE_DELETE_ARRAY_BYTE(gpal);
		MessageBox(GetFocus(),"pbg̎擾Ɏs܂","Clipboard Error",MB_OK);
		return st;
	}
	SAFE_DELETE_ARRAY_BYTE(gpal);
	
	if(!SetClipboardData(CF_PALETTE, hPal)){
		DeleteObject(hPal);
		MessageBox(GetFocus(),"pbgCOPYɎs܂","Clipboard Error",MB_OK);
		return GenericError;
	}
	
	return st;
}// Set_ClipBoard_Pal

// Nbv{[hɃpX
void Set_ClipBoard_Path(PathData *pd, FillMode mode)
{
	if(!pd)	return;
	
	HANDLE		hMem;
	int			*buf1 = NULL;
	BYTE		*buf2 = NULL;
	PointF		*buf3 = NULL;
	FillMode	*buf4 = NULL;
	
	if(pd->Count > 2){
		if(OpenClipboard(NULL)){
			hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, sizeof(int));
			buf1 = (int*) GlobalLock(hMem);
			memcpy(buf1, &pd->Count, sizeof(int));
			SetClipboardData(CF_GDIOBJFIRST+10, hMem);
			GlobalUnlock(hMem);
			hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, sizeof(BYTE)*pd->Count);
			buf2 = (BYTE*) GlobalLock(hMem);
			memcpy(buf2, pd->Types, sizeof(BYTE)*pd->Count);
			SetClipboardData(CF_GDIOBJFIRST+11, hMem);
			GlobalUnlock(hMem);
			hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, sizeof(PointF)*pd->Count);
			buf3 = (PointF*) GlobalLock(hMem);
			memcpy(buf3, pd->Points, sizeof(PointF)*pd->Count);
			SetClipboardData(CF_GDIOBJFIRST+12, hMem);
			GlobalUnlock(hMem);
			hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, sizeof(FillMode));
			buf4 = (FillMode*) GlobalLock(hMem);
			memcpy(buf4, &mode, sizeof(FillMode));
			SetClipboardData(CF_GDIOBJFIRST+13, hMem);
			CloseClipboard();
		}
	}
}// Set_ClipBoard_Path

// Nbv{[hɔF}XNu
void Set_ClipBoard_Alpha(BYTE *mask, int mask_size)
{
	if(!mask)	return;
	
	HANDLE			hMem = NULL;
	int				*buf1 = NULL;
	BYTE			*buf2 = NULL;
	
	if(OpenClipboard(NULL)){
		hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, sizeof(int));
		buf1 = (int*) GlobalLock(hMem);
		memcpy(buf1, &mask_size, sizeof(int));
		SetClipboardData(CF_GDIOBJFIRST+14, hMem);
		GlobalUnlock(hMem);
		hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, mask_size);
		buf2 = (LPBYTE) GlobalLock(hMem);
		memcpy(buf2, mask, mask_size);
		SetClipboardData(CF_GDIOBJFIRST+15, hMem);
		GlobalUnlock(hMem);
		CloseClipboard();
	}
}// Set_ClipBoard_Alpha

// Nbv{[hpXƃ}XN擾
bool Get_ClipBoard2()
{
	// pX擾
	int			*ct    = NULL;
	BYTE		*types = NULL;
	PointF		*pts   = NULL;
	FillMode	*mode  = NULL;
	OpenClipboard(NULL);
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+10)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+10);
		ct =  (int*)GlobalLock (hMem);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+11)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+11);
		types =  (LPBYTE)GlobalLock (hMem);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+12)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+12);
		pts =  (PointF*)GlobalLock (hMem);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+13)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+13);
		mode =  (FillMode*)GlobalLock (hMem);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	SAFE_DELETE_OBJ(ClpBrd.path);
	if(pts && types && ct){
		ClpBrd.path = new GraphicsPath(pts, types, *ct);
		ClpBrd.path->SetFillMode(*mode);
	}
	else{
		CloseClipboard();
		return false;
	}
	// }XN擾
	int *mask_size;
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+14)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+14);
		mask_size = (int*) GlobalLock (hMem);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	if(IsClipboardFormatAvailable(CF_GDIOBJFIRST+15)){
		HANDLE hMem = (HANDLE) GetClipboardData (CF_GDIOBJFIRST+15);
		LPBYTE buf = (LPBYTE) GlobalLock (hMem);
		SAFE_DELETE_ARRAY(ClpBrd.mask);
		ClpBrd.mask = new BYTE [*mask_size];
		memcpy(ClpBrd.mask, buf, *mask_size);
		GlobalUnlock(hMem);
	}
	else{
		CloseClipboard();
		return false;
	}
	CloseClipboard();
	return true;
}// Get_ClipBoard2

// F}XNƃpX̍쐬
Status Get_PathMask(GraphicsPath *path, BYTE *mask, Rect rc)
{
	Status	st = GenericError;
	bool	flag;
	
	if(!path){
		MessageBox(GetFocus(),"path܂","Get_PathMask Error",MB_OK);
		return st;
	}
	Bitmap Bmp(rc.Width, rc.Height, PixelFormat32bppARGB);
	if(Ok != Bmp.GetLastStatus())
		return st;
	Graphics g(&Bmp);
	if(Ok != Bmp.GetLastStatus())
		return st;
	// pXW𕽍sړ
	Matrix mx( 1, 0, 0, 1, -(float)rc.X, -(float)rc.Y );
	path->Transform(&mx);
	if(Ok != Bmp.GetLastStatus())
		return st;
	// pX𔒐Fœhׂ
	g.FillPath(&SolidBrush(Color(255,255,255,255)), path);
	g.DrawPath(&Pen(Color(255, 255, 255, 255), 1), path);
	if(Ok != Bmp.GetLastStatus())
		return st;
	
	if(mask){
		BitmapData	bmpdt;
		Rect rect(0, 0, Bmp.GetWidth(), Bmp.GetHeight());
		
		st = Bmp.LockBits(&rect, ImageLockModeRead, Bmp.GetPixelFormat(), &bmpdt);
		if (st == Ok)
		{
			BYTE	*pxl1 = NULL;
			UINT	stride1;	// 4byteE
			
			if (bmpdt.Stride > 0)
				pxl1 = (BYTE*) bmpdt.Scan0;
			else
				pxl1 = (BYTE*) bmpdt.Scan0
						+ (bmpdt.Stride)*(bmpdt.Height-1);
			stride1 = abs(bmpdt.Stride);
			
			// }XN̍쐬
			flag = false;
			ZeroMemory(mask, bmpdt.Width*bmpdt.Height*sizeof(BYTE));
			for(UINT y=0;y<bmpdt.Height;y++){
				for(UINT x=0;x<bmpdt.Width;x++){
					int ab = stride1*y+4*x;
					if(pxl1[ab+0] == 255){
						mask[y*bmpdt.Width+x] = 255;
					}
					else{
						flag = true;
					}
				}
			}
			st = Bmp.UnlockBits(&bmpdt);
			if(st != Ok){
				MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
				return st;
			}
		}
		else{
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	return Ok;
}// Get_PathMask

// F}XN̓Kp
Status Set_PathMask(Bitmap *Bmp, BYTE *mask)
{
	Status st = GenericError;
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","Set_PathMask Error",MB_OK);
		return st;
	}
	if(!mask){
		MessageBox(GetFocus(),"mask܂","Set_PathMask Error",MB_OK);
		return st;
	}
	PixelFormat	pfmt = Bmp->GetPixelFormat();
	UINT		bpp  = PxFmtToBpp(pfmt);
	int			wdh  = Bmp->GetWidth();
	int			hgt  = Bmp->GetHeight();
	
	if(bpp < 24 || bpp > 32){
		for(int y=0;y<hgt;y++){
			for(int x=0;x<wdh;x++){
				if(!mask[y*wdh+x]){
					st = Bmp->SetPixel(x, y, Color(0,0,0,0));
				}
			}
		}
	}
	else{
		BitmapData	bmpdt;
		Rect rect(0, 0, wdh, hgt);
		st = Bmp->LockBits(&rect, ImageLockModeWrite, pfmt, &bmpdt);
		if (st == Ok)
		{
			BYTE	*pxl1 = NULL;
			UINT	stride1;	// 4byteE
			
			if (bmpdt.Stride > 0)
				pxl1 = (BYTE*) bmpdt.Scan0;
			else
				pxl1 = (BYTE*) bmpdt.Scan0
						+ (bmpdt.Stride)*(bmpdt.Height-1);
			stride1 = abs(bmpdt.Stride);

			UINT	bpp  = PxFmtToBpp(bmpdt.PixelFormat);
			
			// }XN̓Kp
			for(UINT y=0;y<bmpdt.Height;y++){
				for(UINT x=0;x<bmpdt.Width;x++){
					int ab = stride1*y+(bpp/8)*x;
					if(!mask[y*bmpdt.Width+x]){
						pxl1[ab+0] = 0;
						pxl1[ab+1] = 0;
						pxl1[ab+2] = 0;
					}
					if(bpp == 32)
						pxl1[ab+3] = (BYTE) mask[y*bmpdt.Width+x];
				}
			}
			st = Bmp->UnlockBits(&bmpdt);
			if(st != Ok){
				MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
				return st;
			}
		}
		else{
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	return Ok;
}// Set_PathMask

// Alphal𔲂F}XNɒǉiGet_PathMask֐̌ŎgƁj
Status Get_AlphaMask(Bitmap *Bmp, BYTE *mask, Rect rc)
{
	Status st = GenericError;
	if(!(Bmp->GetPixelFormat() & (PixelFormatAlpha | PixelFormatIndexed))){
		return st;
	}
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","Set_PathMask Error",MB_OK);
		return st;
	}
	if(!mask){
		MessageBox(GetFocus(),"mask܂","Set_PathMask Error",MB_OK);
		return st;
	}
	
	Color	clr;
	for(int y=0;y<rc.Height;y++){
		for(int x=0;x<rc.Width;x++){
			Bmp->GetPixel(x+rc.X, y+rc.Y, &clr);
			mask[y*rc.Width+x] &= clr.GetAlpha();
		}
	}
	st = Bmp->GetLastStatus();
	return Ok;
}// Get_AlphaMask
