Bitmap *Bmp_Copy = NULL;		// upO[oBitmapIuWFNg

enum MANU
{
	M_LR  = 1,
	M_TB  = 2,
	M_90  = 3,
	M_180 = 4,
	M_270 = 5
};

Status Copy_Image(Bitmap *Bmp, int width, int height, PixelFormat format, InterpolationMode imode);
Status Rotate_Image(Bitmap *Bmp, REAL deg, bool flag_Reverse, bool flag_Smooth);
Status Mirror_Image(Bitmap *Bmp, MANU flag_Manu);
Status Mirror_Image8 (Bitmap *Bmp,int wdh_dst, int hgt_dst, MANU flag_Manu);
Status Mirror_Image32(Bitmap *Bmp,int wdh_dst, int hgt_dst, MANU flag_Manu);
Status Change_Pfmt32(Bitmap *Bmp, PixelFormat pfmt_dst, bool bAlpha);

// Bmp̃TCYƃsNZtH[}bgύXāABmp_Copyɓ
Status Copy_Image(Bitmap *Bmp, int width, int height, PixelFormat format, InterpolationMode imode)
{
	Status	st;
	
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","",MB_OK);
		return (GenericError);
	}
	SAFE_DELETE_OBJ(Bmp_Copy);
	Bmp_Copy = new Bitmap(width, height, format);
	
	if(!Bmp_Copy){
		MessageBox(GetFocus(),"Bmp_Copy쐬ł܂","",MB_OK);
		return (GenericError);
	}
	
	// BmpBmp_CopyɃRs[ĉnig߁j
	Graphics g(Bmp_Copy);
	g.SetPixelOffsetMode(PixelOffsetModeHalf);
	g.SetInterpolationMode(InterpolationModeNearestNeighbor);
	st = g.DrawImage(Bmp, 0, 0, width, height);
	
	// dグ`
	if(st == Ok && imode != InterpolationModeNearestNeighbor){
		g.SetPixelOffsetMode(PixelOffsetModeDefault);
		g.SetInterpolationMode(imode);
		st = g.DrawImage(Bmp, 0, 0, width, height);
	}
	
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copyɕ`ł܂","",MB_OK);
		SAFE_DELETE_OBJ(Bmp_Copy);
	}
	return (st);
}// Copy_Image

// BmpCӂ̊pxɉ]Bmp_Copyɓ
// degFpx@flag_ReverseFt]tO@flag_SmoothFX[WOtO
Status Rotate_Image(Bitmap *Bmp, REAL deg, bool flag_Reverse, bool flag_Smooth)
{
	Status		st;
	PixelFormat	pf;
	int			dx,dy,dia,x_c,y_c;
	
	if(!((int)deg % 90)){
		if(!((int)deg % 270)){
			if(flag_Reverse)
				st = Mirror_Image(Bmp, M_90);
			else
				st = Mirror_Image(Bmp, M_270);
		}
		else if(!((int)deg % 180)){
			st = Mirror_Image(Bmp, M_180);
		}
		else{
			if(flag_Reverse)
				st = Mirror_Image(Bmp, M_270);
			else
				st = Mirror_Image(Bmp, M_90);
		}
		return st;
	}
	
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","",MB_OK);
		return (GenericError);
	}
	
	if(Bmp->GetPixelFormat() & PixelFormatIndexed)
		pf = PixelFormat32bppARGB;
	else
		pf = Bmp->GetPixelFormat();
	
	SAFE_DELETE_OBJ(Bmp_Copy);
	
	Bmp->GetWidth() > Bmp->GetHeight() ? dia = Bmp->GetWidth() : dia = Bmp->GetHeight();
	if(Bmp->GetWidth() != Bmp->GetHeight()){
		x_c = Bmp->GetWidth() / 2;
		y_c = Bmp->GetHeight() / 2;
		dia = (int) sqrt(x_c * x_c + y_c * y_c) * 2;
		dx = (dia - Bmp->GetWidth()) / 2;
		dy = (dia - Bmp->GetHeight()) / 2;
		Bmp_Copy = new Bitmap(dia, dia, pf);
	}
	else{
		Bmp_Copy = new Bitmap(Bmp->GetWidth(), Bmp->GetHeight(), pf);
	}
	
	st = Bmp_Copy->GetLastStatus();
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copy쐬ł܂","",MB_OK);
	}
	
	Graphics g(Bmp_Copy);
	if(flag_Smooth){
		g.SetPixelOffsetMode(PixelOffsetModeDefault);
		g.SetInterpolationMode(InterpolationModeBicubic);
	}
	else{
		g.SetPixelOffsetMode(PixelOffsetModeHalf);
		g.SetInterpolationMode(InterpolationModeNearestNeighbor);
	}

	PointF pt;
	if(Bmp->GetWidth() != Bmp->GetHeight()){
		pt.X = (float) dia / 2;
		pt.Y = (float) dia / 2;
	}
	else{
		pt.X = (float) Bmp->GetWidth() / 2;
		pt.Y = (float) Bmp->GetHeight() / 2;
	}
	
	Matrix mx;
	mx.RotateAt( deg, pt );
	if(flag_Reverse)
		mx.Invert();	// t]
	g.SetTransform( &mx );
	
	if(Bmp->GetWidth() != Bmp->GetHeight())
		st = g.DrawImage(Bmp, dx, dy, Bmp->GetWidth(), Bmp->GetHeight());
	else
		st = g.DrawImage(Bmp, 0, 0, Bmp->GetWidth(), Bmp->GetHeight());
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copyɕ`ł܂","",MB_OK);
		Bmp_Copy = Bmp->Clone(0, 0, Bmp->GetWidth(), Bmp->GetHeight(), Bmp->GetPixelFormat());
	}
	
	return (st);
}// Rotate_Image

// Bmp㉺EE]A90,180,270x]Bmp_Copyɓ
Status Mirror_Image(Bitmap *Bmp, MANU flag_Manu)
{
	Status		st;
	int			wdh,hgt;
	
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","",MB_OK);
		return (GenericError);
	}
	
	if(flag_Manu == M_90 || flag_Manu == M_270){
		wdh = Bmp->GetHeight();
		hgt = Bmp->GetWidth();
	}
	else{
		wdh = Bmp->GetWidth();
		hgt = Bmp->GetHeight();
	}
	
	SAFE_DELETE_OBJ(Bmp_Copy);

	Bmp_Copy = new Bitmap(wdh, hgt, Bmp->GetPixelFormat());
	
	st = Bmp_Copy->GetLastStatus();
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copy쐬ł܂","",MB_OK);
	}

	if(Bmp->GetPixelFormat() & PixelFormatIndexed)
		Mirror_Image8 (Bmp, wdh, hgt, flag_Manu);
	else
		Mirror_Image32(Bmp, wdh, hgt, flag_Manu);
	
	return (st);
}// Mirror_Image

// CfbNXJ[Bmp㉺EE]A90,180,270x]Bmp_Copyɓ
Status Mirror_Image8(Bitmap *Bmp,int wdh_dst, int hgt_dst, MANU flag_Manu)
{
	Status		st = GenericError;
	
	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","",MB_OK);
		return st;
	}

	if(!(Bmp->GetPixelFormat() & PixelFormatIndexed)){
		MessageBox(GetFocus(),"CfbNXJ[ł͂܂","",MB_OK);
		return st;
	}

	int			wdh_src	= Bmp->GetWidth();
	int			hgt_src	= Bmp->GetHeight();
	PixelFormat	pfmt	= Bmp->GetPixelFormat();
	int 		bpp		= PxFmtToBpp(pfmt);
	BitmapData	bitmapData;
	Rect		rect(0, 0, wdh_src, hgt_src);
	BYTE		*pxl2 = NULL,*pxl3 = NULL;
	int			x,y;
	
	// 1,4,8bitJ[fvXʂɃsNZf[^ǂݍ
	st = Bmp->LockBits(&rect, ImageLockModeRead, Bmp->GetPixelFormat(), &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride;	// 4byteE
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride = abs(bitmapData.Stride);
		
		pxl2 = new BYTE [wdh_src*hgt_src*sizeof(BYTE)];
		ZeroMemory(pxl2, wdh_src*hgt_src*sizeof(BYTE));
		
		for(y=0; y<hgt_src; y++){
			for(x=0; x<wdh_src/(8/bpp); x++){
				switch (bpp)
				{
				case 1:
					pxl2[wdh_src*y+x*8+0] = (pxl1[stride*y+x] >> 7) & 1;
					pxl2[wdh_src*y+x*8+1] = (pxl1[stride*y+x] >> 6) & 1;
					pxl2[wdh_src*y+x*8+2] = (pxl1[stride*y+x] >> 5) & 1;
					pxl2[wdh_src*y+x*8+3] = (pxl1[stride*y+x] >> 4) & 1;
					pxl2[wdh_src*y+x*8+4] = (pxl1[stride*y+x] >> 3) & 1;
					pxl2[wdh_src*y+x*8+5] = (pxl1[stride*y+x] >> 2) & 1;
					pxl2[wdh_src*y+x*8+6] = (pxl1[stride*y+x] >> 1) & 1;
					pxl2[wdh_src*y+x*8+7] =  pxl1[stride*y+x]       & 1;
					break;
				case 4:
					pxl2[wdh_src*y+x*2+0] = pxl1[stride*y+x] >> 4;
					pxl2[wdh_src*y+x*2+1] = pxl1[stride*y+x] & 0xf;
					break;
				case 8:
					pxl2[wdh_src*y+x] = pxl1[stride*y+x];
				}
			}
		}

		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl2);
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}

	pxl3 = new BYTE [wdh_dst*hgt_dst*sizeof(BYTE)];
	ZeroMemory(pxl3, wdh_dst*hgt_dst*sizeof(BYTE));

	UINT r_x,r_y;	// ]̍W

	for(y=0; y<hgt_src; y++){
		for(x=0; x<wdh_src; x++){
			if(flag_Manu == M_LR){
				pxl3[wdh_dst*y+(wdh_dst-x-1)] = pxl2[wdh_src*y+x];
			}
			else if(flag_Manu == M_TB){
				pxl3[wdh_dst*(hgt_dst-y-1)+x] = pxl2[wdh_src*y+x];
			}
			else if(flag_Manu == M_90){
				r_x = 0 * x - 1 * y + wdh_dst - 1;
				r_y = 1 * x + 0 * y;
				pxl3[wdh_dst*r_y+r_x] = pxl2[wdh_src*y+x];
			}
			else if(flag_Manu == M_180){
				r_x = -1 * x - 0 * y + wdh_dst - 1;
				r_y =  0 * x - 1 * y + hgt_dst - 1;
				pxl3[wdh_dst*r_y+r_x] = pxl2[wdh_src*y+x];
			}
			else if(flag_Manu == M_270){
				r_x =  0 * x + 1 * y;
				r_y = -1 * x + 0 * y + hgt_dst - 1;
				pxl3[wdh_dst*r_y+r_x] = pxl2[wdh_src*y+x];
			}
		}
	}
	
	SAFE_DELETE_ARRAY(pxl2);

	// pbg̐ݒ
	ColorPalette	*ppal = NULL;
	int p_sz = Bmp->GetPaletteSize();
	ppal = (ColorPalette*) new BYTE [p_sz];
	if (ppal == NULL){
		return OutOfMemory;
	}
	st = Bmp->GetPalette(ppal, p_sz);
	if(st != Ok){
		MessageBox(GetFocus(),"pbg擾ł܂","",MB_OK);
		SAFE_DELETE_ARRAY_BYTE(ppal);
		return st;
	}
	st = Bmp_Copy->SetPalette(ppal);
	if(st != Ok){
		MessageBox(GetFocus(),"pbgݒł܂","",MB_OK);
		SAFE_DELETE_ARRAY_BYTE(ppal);
		return st;
	}
	SAFE_DELETE_ARRAY_BYTE(ppal);

	Rect	rect2(0, 0, wdh_dst, hgt_dst);

	// Bmp_CopyɃsNZf[^1,4,8bitJ[fvXʂɏ
	st = Bmp_Copy->LockBits(&rect2, ImageLockModeWrite, Bmp_Copy->GetPixelFormat(), &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride;	// 4byteE
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride = abs(bitmapData.Stride);
		
		ZeroMemory(pxl1, stride*bitmapData.Height);

		for(y=0; y<hgt_dst; y++){
			for(x=0; x<wdh_dst; x++){
				switch (bpp)
				{
				case 1:
					pxl1[stride*y+x/8] |= (pxl3[wdh_dst*y+x] & 1) << (7 - (x % 8));
					break;
				case 4:
					pxl1[stride*y+x/2] |= (pxl3[wdh_dst*y+x] & 0xf) << (4 - (x % 2) * 4);
					break;
				case 8:
					pxl1[stride*y+x] = pxl3[wdh_dst*y+x];
				}
			}
		}

		st = Bmp_Copy->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl3);
			MessageBox(GetFocus(),"Bmp_CopybNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"Bmp_CopybNł܂","",MB_OK);
		return st;
	}
	SAFE_DELETE_ARRAY(pxl3);
	return st;
}// Mirror_Image8

// tJ[Bmp㉺EE]A90,180,270x]Bmp_Copyɓ
Status Mirror_Image32(Bitmap *Bmp,int wdh_dst, int hgt_dst, MANU flag_Manu)
{
	Status	st = GenericError;
	Point	pt1[4];
	Rect	rc (0, 0, wdh_dst, hgt_dst);
	RectToPoint(pt1, rc);
	
	Point pt2[4] = {pt1[1], pt1[0], pt1[3], pt1[2]};
	Point pt3[4] = {pt1[2], pt1[3], pt1[0], pt1[1]};
	Point pt4[4] = {pt1[1], pt1[3], pt1[0], pt1[2]};
	Point pt5[4] = {pt1[3], pt1[2], pt1[1], pt1[0]};
	Point pt6[4] = {pt1[2], pt1[0], pt1[3], pt1[1]};
	
	Graphics g(Bmp_Copy);
	g.SetPixelOffsetMode(PixelOffsetModeHalf);
	g.SetInterpolationMode(InterpolationModeNearestNeighbor);
	
	if(flag_Manu == M_LR)
		st = g.DrawImage(Bmp, pt2, 3);
	else if(flag_Manu == M_TB)
		st = g.DrawImage(Bmp, pt3, 3);
	else if(flag_Manu == M_90)
		st = g.DrawImage(Bmp, pt4, 3);
	else if(flag_Manu == M_180)
		st = g.DrawImage(Bmp, pt5, 3);
	else if(flag_Manu == M_270)
		st = g.DrawImage(Bmp, pt6, 3);
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copyɕ`ł܂","",MB_OK);
		Bmp_Copy = Bmp->Clone(0, 0, Bmp->GetWidth(), Bmp->GetHeight(), Bmp->GetPixelFormat());
	}
	return st;
}// Mirror_Image32

// tJ[tH[}bgϊi16,24,32bitj
// Bmp		F[IN][OUT] rbg}bv IuWFNg
// pfmt_dst	F[IN]      ϊ̃sNZ tH[}bg
// bAlpha	F[IN]      xݒ肷ꍇ true
Status Change_Pfmt32(Bitmap *Bmp, PixelFormat pfmt_dst, bool bAlpha)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	int			wdh			= Bmp->GetWidth();
	int			hgt			= Bmp->GetHeight();
	PixelFormat	pfmt_src	= Bmp->GetPixelFormat();
	int 		bpp_src,bpp_dst;
	Rect		rect(0, 0, wdh, hgt);
	BYTE		*pxl2 = NULL;
	
	bpp_src = PxFmtToBpp(pfmt_src);
	bpp_dst = PxFmtToBpp(pfmt_dst);

	if(pfmt_dst & PixelFormatIndexed){
		MessageBox(GetFocus(),"CfbNXJ[͑ΉĂ܂","",MB_OK);
		return st;
	}
	if(bpp_dst >= 48){
		MessageBox(GetFocus(),"48bitFȏ͑ΉĂ܂","",MB_OK);
		return st;
	}

	if(!Bmp){
		MessageBox(GetFocus(),"Bmp܂","",MB_OK);
		return st;
	}
	SAFE_DELETE_OBJ(Bmp_Copy);
	Bmp_Copy = new Bitmap(wdh, hgt, pfmt_dst);
	
	st = Bmp->GetLastStatus();
	if(st != Ok){
		MessageBox(GetFocus(),"Bmp_Copy쐬ł܂","",MB_OK);
	}

	if(bpp_src >= 48){
		bpp_src = 32;
		pfmt_src = PixelFormat32bppARGB;
	}

	st = Bmp->LockBits(&rect, ImageLockModeRead, pfmt_src, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride1;	// 4byteE
		int		w,x,y,y2,ab1,ab2;
		DWORD	argb;
		BARGB	bArgb;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		pxl2 = new BYTE [wdh*hgt*sizeof(BYTE)*4];
		ZeroMemory(pxl2, wdh*hgt*sizeof(BYTE)*4);
		
		
		if(pfmt_src & PixelFormatIndexed){	// 1,4,8bitf[^ǂݍ
			ColorPalette	*ppal1 = NULL;
			int				p_sz;
			p_sz = Bmp->GetPaletteSize();
			ppal1 = (ColorPalette*) new BYTE [p_sz];
			Bmp->GetPalette(ppal1, p_sz);
			st = Bmp->GetLastStatus();
			if(st != Ok){
				SAFE_DELETE_ARRAY_BYTE(ppal1);
				MessageBox(GetFocus(),"pbg擾ł܂","",MB_OK);
				return st;
			}
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh/(8/bpp_src); x++){
					ab2 = wdh*4*y+x*(8/bpp_src)*4;
					if(bitmapData.Stride > 0)
						y2 = hgt - y - 1;
					else
						y2 = y;
					ab1 = stride1*y2+x;
					switch (bpp_src)
					{
					case 1:
						for(w=0; w<8; w++){
							argb = (pxl1[ab1] >> (7-w)) & 1;
							bArgb = ArgbToBargb(ppal1->Entries[argb], PixelFormat32bppARGB);
							pxl2[ab2+w*4+0] = bArgb.B;
							pxl2[ab2+w*4+1] = bArgb.G;
							pxl2[ab2+w*4+2] = bArgb.R;
							pxl2[ab2+w*4+3] = bArgb.A;
						}
						break;
					case 4:
						argb = pxl1[ab1] >> 4;
						bArgb = ArgbToBargb(ppal1->Entries[argb], PixelFormat32bppARGB);
						pxl2[ab2+0] = bArgb.B;
						pxl2[ab2+1] = bArgb.G;
						pxl2[ab2+2] = bArgb.R;
						pxl2[ab2+3] = bArgb.A;
						argb = pxl1[ab1] & 0xf;
						bArgb = ArgbToBargb(ppal1->Entries[argb], PixelFormat32bppARGB);
						pxl2[ab2+4] = bArgb.B;
						pxl2[ab2+5] = bArgb.G;
						pxl2[ab2+6] = bArgb.R;
						pxl2[ab2+7] = bArgb.A;
						break;
					case 8:
						bArgb = ArgbToBargb(ppal1->Entries[pxl1[ab1]], PixelFormat32bppARGB);
						pxl2[ab2+0] = bArgb.B;
						pxl2[ab2+1] = bArgb.G;
						pxl2[ab2+2] = bArgb.R;
						pxl2[ab2+3] = bArgb.A;
					}
				}
			}
			SAFE_DELETE_ARRAY_BYTE(ppal1);
		}
		else{	// 16,24,32bitf[^ǂݍ
			for(y=0;y<hgt;y++){
				for(x=0;x<wdh;x++){
					ab2 = wdh*4*y+x*4;
					if(bitmapData.Stride > 0)
						y2 = hgt - y - 1;
					else
						y2 = y;
					ab1 = stride1*y2+x*bpp_src/8;
					switch (bpp_src)
					{
					case 32:
					case 24:
						pxl2[ab2+0] = pxl1[ab1+0];
						pxl2[ab2+1] = pxl1[ab1+1];
						pxl2[ab2+2] = pxl1[ab1+2];
						if(bpp_src == 32)
							pxl2[ab2+3] = pxl1[ab1+3];
						else
							pxl2[ab2+3] = 0xff;
						break;
					case 16:
						argb = pxl1[ab1+0];
						argb |= pxl1[ab1+1] << 8;
						bArgb = ArgbToBargb(argb, pfmt_src);
						pxl2[ab2+0] = bArgb.B;
						pxl2[ab2+1] = bArgb.G;
						pxl2[ab2+2] = bArgb.R;
						pxl2[ab2+3] = bArgb.A;
					}
				}
			}
		}
		
		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl2);
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}

	// Bmpݐprbg}bv̈ƂăbN
	st = Bmp_Copy->LockBits(&rect, ImageLockModeWrite, pfmt_dst, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride2;	// 4byteE
		int		x,y,y2,ab1,ab2;
		DWORD	argb;
		BARGB	bArgb;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride2 = abs(bitmapData.Stride);
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				ab2 = wdh*4*y+x*4;
				if(bitmapData.Stride > 0)
						y2 = hgt - y - 1;
					else
						y2 = y;
				ab1 = stride2*y2+x*bpp_dst/8;
				switch (bpp_dst)
				{
				case 32:
					pxl1[ab1+0] = pxl2[ab2+0];
					pxl1[ab1+1] = pxl2[ab2+1];
					pxl1[ab1+2] = pxl2[ab2+2];
					if(bAlpha){
						pxl1[ab1+3] = pxl2[ab2+3];
					}
					else{
						if(pfmt_dst & PixelFormatAlpha)
							pxl1[ab1+3] = pxl2[ab2+3];
						else
							pxl1[ab1+3] = 0xff;
					}
					break;
				case 24:
					pxl1[ab1+0] = pxl2[ab2+0];
					pxl1[ab1+1] = pxl2[ab2+1];
					pxl1[ab1+2] = pxl2[ab2+2];
					break;
				case 16:
					bArgb.B = pxl2[ab2+0];
					bArgb.G = pxl2[ab2+1];
					bArgb.R = pxl2[ab2+2];
					bArgb.A = pxl2[ab2+3];
					argb = BargbToArgb(bArgb, pfmt_dst);
					pxl1[ab1+0] = (BYTE) argb;
					pxl1[ab1+1] = (BYTE)(argb >> 8);
				}
			}
		}
		
		st = Bmp_Copy->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl2);
			MessageBox(GetFocus(),"Bmp_CopybNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"Bmp_CopybNł܂","",MB_OK);
		return st;
	}
	SAFE_DELETE_ARRAY(pxl2);
	return st;
}// Change_Pfmt32
