#include <time.h>

Status	Effect(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, GraphicsPath *path, BYTE *path_mask, int index, UINT prm1);
Status	Effect1(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, BYTE *path_mask, int index, UINT prm1);
Status	Effect2(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, GraphicsPath *path, int index, UINT prm1);
BYTE 	Luminosity(UINT clr, UINT prm1);
BYTE 	Contrast(UINT clr, UINT prm1, float min, float max);
void	Saturation(BYTE *pxl_W, int ab, UINT prm1);
BYTE 	Negative(BYTE clr, UINT prm1);
void	Monotone(BYTE *pxl);
BYTE 	Sola(UINT clr, UINT prm1, int clr2);
BYTE	Post(UINT clr, UINT prm1);
void	Mosaic(BYTE *pxl_R, DWORD *pxl7R, DWORD *pxl7G, DWORD *pxl7B, int bpp, int wdh, int hgt, int stride, int size);
int		Get_Value(BYTE *pxl_R, int bpp, int stride, int wdh, int hgt, int x, int y, int *mask, int size, int i_rgb);
int		Get_Pixel(BYTE *pxl_R, int bpp, int stride, int wdh, int hgt, int x, int y, int i_rgb);
void	Set_Pixel(BYTE *pxl_W, int val, int bpp, int stride, int x, int y, int i_rgb);
int		Cmp(const BYTE *a, const BYTE *b);
void	Blur(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
void	BlurAlpha(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
int		Blur_Sub(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, int idxRGB, UINT prm1);
void	Sharpness(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
void	Edge(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
void	Emboss(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
void	Noise(BYTE *pxl_R, BYTE *pxl_W, int ab, UINT prm1);
void	Remove_Noise(BYTE *pxl_R, BYTE *pxl_W, int ab, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1);
void	Hue(BYTE *pxl_R, BYTE *pxl_W, int ab, UINT prm1);
void	Circle(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int x1, int y1, int x2, int y2, UINT prm1);
void	AntiAlias(BYTE *pxl_R, BYTE *pxl_W, BYTE *mask, UINT bpp, UINT stride, UINT wdh, UINT hgt, float div);
void	AntiAlias2(BYTE *pxl_R, BYTE *pxl_W, BYTE *mask, UINT bpp, UINT stride, UINT wdh, UINT hgt);
void	AntiAlias2_Sub(BYTE *pxl_R, BYTE *pxl_W, BYTE *mask, UINT bpp, UINT stride, UINT wdh, UINT hgt, bool bVert);
void	AntiAlias2_Sub2(int *val, int *equal_ct, BYTE *pxl_R, UINT bpp, UINT stride, UINT wdh, UINT hgt, UINT x, UINT y, int val_RA);
void	AntiAlias3(BYTE *pxl_R, BYTE *pxl_W, BYTE *mask, UINT bpp, UINT stride, UINT wdh, UINT hgt);
void	Halftone(BYTE *clr, int x, int y, UINT prm1);
void	Halftone2(BYTE *clr, int x, int y, UINT prm1);
void	Halftone_Sub(BYTE *clr, int x, int y, float val, UINT prm1);
void	TwoColor(BYTE *pxl_W, int ab, int stride, int wdh, int hgt, int x, int y, BYTE BrtBorder, BYTE BrtMax, BYTE BrtMin, float rate, bool flag_Dither);
int		RandTo(int max);
void	Square(BYTE *pxl_R, BYTE *mask, int bpp, int stride, int wdh, int hgt);

Status Effect(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, GraphicsPath *path, BYTE *path_mask, int index, UINT prm1)
{
	Status	st = GenericError;
	
	UINT		wdh  = Bmp_R->GetWidth();
	UINT		hgt  = Bmp_R->GetHeight();
	PixelFormat	pfmt = Bmp_R->GetPixelFormat();
	UINT		bpp  = PxFmtToBpp(pfmt);
	
	if(!Bmp_R || !Bmp_W){
		MessageBox(GetFocus(),"mۂĂ܂","",MB_OK);
		return st;
	}
	
	if(wdh != Bmp_W->GetWidth() || hgt != Bmp_W->GetHeight() || pfmt != Bmp_W->GetPixelFormat()){
		MessageBox(GetFocus(),"ǂݏBMPIuWFNg̑傫ƃtH[}bgقȂ܂","",MB_OK);
		return st;
	}
	
	if(bpp != 32){
		MessageBox(GetFocus(),"tH[}bgΉĂ܂","",MB_OK);
		return st;
	}
	
	if(index < 23)
		Effect1(flag_Preview, Bmp_R, Bmp_W, path_mask, index, prm1);
	else
		Effect2(flag_Preview, Bmp_R, Bmp_W, path, index, prm1);
	return st;
}// Effect

// ʂ̓Kpi32bitFj
// flag_Preview : vr[̂Ƃ TRUE
// Bmp_R        : ǂݍݗprbg}bvIuWFNg
// Bmp_W        : ݗprbg}bvIuWFNg
// path_mask    : GtFNg͈̓}XN
// index        : GtFNgԍ
// prm1         : XC_̈ʒu
Status Effect1(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, BYTE *path_mask, int index, UINT prm1)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	UINT		wdh  = Bmp_R->GetWidth();
	UINT		hgt  = Bmp_R->GetHeight();
	PixelFormat	pfmt = Bmp_R->GetPixelFormat();
	UINT		bpp  = PxFmtToBpp(pfmt);
	Rect		rect(0, 0, wdh, hgt);
	BYTE		*pxl_R = NULL;			// ǂݍ݉摜̉fl
	DWORD		*pxl7R = NULL,*pxl7G = NULL,*pxl7B = NULL;	// UCNp
	BYTE		BrtBorder;	// 2l摜p
	float		ave,min,max,rate;
	int			i;
	
	if(!Bmp_R || !Bmp_W){
		return st;
	}
	
	if(wdh != Bmp_W->GetWidth() || hgt != Bmp_W->GetHeight() || pfmt != Bmp_W->GetPixelFormat()){
		return st;
	}
	
	if(bpp != 32){
		return st;
	}
	
	// Bmp_Rǂݍݐprbg}bv̈ƂăbN
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride1;	// 4byteE
		UINT	x,y,ab1;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		if(flag_Preview || (index >= 9 && index < 19)){
			pxl_R = new BYTE [stride1*hgt*sizeof(BYTE)];
			memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
		}
		
		switch (index)
		{
		case 1:		// RgXg
		case 4:		// F]EmN
		case 7:		// ~iX At@
		case 21:	// 2l摜
		case 22:	// 2l摜ifBUj
			min = 255;
			max = 0;
			for(y=0;y<hgt;y++){
				for(x=0;x<wdh;x++){
					ab1 = stride1*y+x*bpp/8;
					ave = (float)(pxl1[ab1+0]+pxl1[ab1+1]+pxl1[ab1+2])/3;
					if(ave <= min){
						min = ave;
					}
					if(ave >= max){
						max = ave;
					}
				}
			}
			break;
		case 8:		// UCN
			if(prm1){
				UINT size = prm1 + 1;
				pxl7R = new DWORD [(wdh/size+1)*(hgt/size+1)];
				ZeroMemory(pxl7R, sizeof(DWORD)*(wdh/size+1)*(hgt/size+1));
				pxl7G = new DWORD [(wdh/size+1)*(hgt/size+1)];
				ZeroMemory(pxl7G, sizeof(DWORD)*(wdh/size+1)*(hgt/size+1));
				pxl7B = new DWORD [(wdh/size+1)*(hgt/size+1)];
				ZeroMemory(pxl7B, sizeof(DWORD)*(wdh/size+1)*(hgt/size+1));
				Mosaic(pxl1, pxl7R, pxl7G, pxl7B, bpp, wdh, hgt, stride1, size);
			}
			break;
		}
		
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			SAFE_DELETE_ARRAY(pxl_R);
			SAFE_DELETE_ARRAY(pxl7R);
			SAFE_DELETE_ARRAY(pxl7G);
			SAFE_DELETE_ARRAY(pxl7B);
			MessageBox(GetFocus(),"Bmp_RbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		SAFE_DELETE_ARRAY(pxl_R);
		SAFE_DELETE_ARRAY(pxl7R);
		SAFE_DELETE_ARRAY(pxl7G);
		SAFE_DELETE_ARRAY(pxl7B);
		MessageBox(GetFocus(),"Bmp_RbNł܂","",MB_OK);
		return st;
	}
	
	int	sola_tbl[256];
	int	gamma_tbl[256];
	switch (index)
	{
	case 0:		// x
		if(prm1 > 100){	// 邭
			prm1 = ((int) prm1 - 100) * 255 / 100;
		}
		else{			// Â
			prm1 = - (100 - (int) prm1) * 255 / 100;
		}
		break;
	case 2:		// K}␳
		double	a;
		for(i=0;i<256;i++){
			a = (double) i / 255.0;
			if(prm1 >= 50)
				gamma_tbl[i] = (int)(pow(a, ((double)prm1-40.0)/10.0) * 255.0);
			else
				gamma_tbl[i] = (int)(pow(a, 1.0/((60.0-(double)prm1)/10.0)) * 255.0);
		}
		break;
	case 5:		// \[[V
		switch (prm1)
		{
		case 1:
		case 4:
			for(i=0;i<128;i++)
				sola_tbl[i] = 2 * i;
			for(i=128;i<256;i++)
				sola_tbl[i] = 254 - 2 * (i - 128);
			break;
		case 2:
		case 5:
			for(i=0;i<85;i++)
				sola_tbl[i] = 3 * i;
			for(i=85;i<170;i++)
				sola_tbl[i] = 255 - 3 * (i - 85);
			for(i=170;i<255;i++)
				sola_tbl[i] = 3 * (i - 170);
			sola_tbl[255] = 252;
			break;
		case 3:
		case 6:
			for(i=0;i<64;i++)
				sola_tbl[i] = 4 * i + 1;
			for(i=64;i<128;i++)
				sola_tbl[i] = 253 - 4 * (i - 64);
			for(i=128;i<192;i++)
				sola_tbl[i] = 4 * (i - 128) + 1;
			for(i=192;i<256;i++)
				sola_tbl[i] = 253 - 4 * (i - 192);
			break;
		}
		break;
	case 14:	// mCY
		srand( (unsigned)time( NULL ) );
		break;
	case 21:	// 2l摜
	case 22:	// 2l摜ifBUj
		rate = (float)prm1 / 100;
		if(rate > 1){
			rate = 1;
		}
		else if(rate < 0){
			rate = 0;
		}
		BrtBorder = (BYTE)(max * rate + min * (1 - rate));
		break;
	}
	
	// Bmp_Wǂݏprbg}bv̈ƂăbN
	st = Bmp_W->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride1;	// 4byteE
		UINT	x,y,ab1;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		if(flag_Preview && pxl_R){
			memcpy(pxl1, pxl_R, stride1*hgt*sizeof(BYTE));
		}
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				if(path_mask && !path_mask[y*wdh+x]){
					continue;
				}
				ab1 = stride1*y+x*bpp/8;
				switch (index)
				{
				case 0:		// x
					pxl1[ab1+0] = Luminosity(pxl1[ab1+0], prm1);
					pxl1[ab1+1] = Luminosity(pxl1[ab1+1], prm1);
					pxl1[ab1+2] = Luminosity(pxl1[ab1+2], prm1);
					break;
				case 1:		// RgXg
					pxl1[ab1+0] = Contrast(pxl1[ab1+0], prm1, min, max);
					pxl1[ab1+1] = Contrast(pxl1[ab1+1], prm1, min, max);
					pxl1[ab1+2] = Contrast(pxl1[ab1+2], prm1, min, max);
					break;
				case 2:		// K}␳
					pxl1[ab1+0] = gamma_tbl[pxl1[ab1+0]];
					pxl1[ab1+1] = gamma_tbl[pxl1[ab1+1]];
					pxl1[ab1+2] = gamma_tbl[pxl1[ab1+2]];
					break;
				case 3:		// ʓx
					Saturation(pxl1, ab1, prm1);
					break;
				case 4:		// F]
					if(prm1 <= 1){
						pxl1[ab1+0] = Negative(pxl1[ab1+0], prm1);
						pxl1[ab1+1] = Negative(pxl1[ab1+1], prm1);
						pxl1[ab1+2] = Negative(pxl1[ab1+2], prm1);
					}
					else if(prm1 == 2){
						pxl1[ab1+0] = (BYTE) min;
						pxl1[ab1+2] = (BYTE) max;
					}
					else if(prm1 == 3){
						pxl1[ab1+0] = (BYTE) min;
						pxl1[ab1+1] = 255 - pxl1[ab1+1];
						pxl1[ab1+2] = (BYTE) max;
					}
					else if(prm1 == 4){
						pxl1[ab1+0] = (BYTE) min;
					}
					else if(prm1 == 5){
						pxl1[ab1+0] = (BYTE) max;
					}
					else if(prm1 == 6){
						Monotone(&pxl1[ab1]);
					}
					break;
				case 5:		// \[[V
					if(prm1 > 3){
						Monotone(&pxl1[ab1]);
					}
					pxl1[ab1+0] = Sola(pxl1[ab1+0], prm1, sola_tbl[pxl1[ab1+0]]);
					pxl1[ab1+1] = Sola(pxl1[ab1+1], prm1, sola_tbl[pxl1[ab1+1]]);
					pxl1[ab1+2] = Sola(pxl1[ab1+2], prm1, sola_tbl[pxl1[ab1+2]]);
					break;
				case 6:		// |X^[[V
					pxl1[ab1+0] = Post(pxl1[ab1+0], prm1);
					pxl1[ab1+1] = Post(pxl1[ab1+1], prm1);
					pxl1[ab1+2] = Post(pxl1[ab1+2], prm1);
					break;
				case 7:		// ~iX At@
					if(prm1 > 0){
						ave = (float)(pxl1[ab1+0] + pxl1[ab1+1] + pxl1[ab1+2]) / 3;
						if(!(prm1 % 2)){
							if(max != min){
								ave = (float)(ave - min) * 255 / (float)fabs(max - min);
							}
						}
						if(prm1 == 3 || prm1 == 4){
							ave = (float)sqrt(255.0 * ave);	// 񎟋Ȑ
						}
						else if(prm1 == 7 || prm1 == 8){
							ave = (float)ave * ave / 255;	// 񎟋Ȑ
						}
						if(ave < 0)		ave = 0;
						if(ave > 255)	ave = 255;
						if(prm1 >= 5){
							ave = (BYTE) (255 - ave);
						}
						if(pxl1[ab1+3] < (255 - (BYTE) ave)){
							pxl1[ab1+3] = 0;
						}
						else{
							pxl1[ab1+3] -= (255 - (BYTE) ave);
						}
					}
					break;
				case 8:		// UCN
					if(prm1 > 0){
						UINT size = prm1 + 1;
						if(size > wdh / 2)
							size = wdh / 2;
						if(size > hgt / 2)
							size = hgt / 2;
						UINT wdh2 = wdh - (wdh % size);
						UINT ab2 = (y/size)*(wdh2/size+1)+x/size;
						pxl1[ab1+0] = (BYTE) pxl7B[ab2];
						pxl1[ab1+1] = (BYTE) pxl7G[ab2];
						pxl1[ab1+2] = (BYTE) pxl7R[ab2];
					}
					break;
				case 9:		// ڂ
					if(prm1){
						Blur(pxl_R, pxl1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 10:	// ڂix̂݁j
					if(prm1){
						BlurAlpha(pxl_R, pxl1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 11:	// V[v
					if(prm1){
						Sharpness(pxl_R, pxl1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 12:	// GbWo
					if(prm1){
						Edge(pxl_R, pxl1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 13:	// G{X
					if(prm1){
						Emboss(pxl_R, pxl1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 14:	// mCY
					if(prm1){
						Noise(pxl_R, pxl1, ab1, prm1);
					}
					break;
				case 15:	// mCY
					if(prm1){
						Remove_Noise(pxl_R, pxl1, ab1, bpp, stride1, wdh, hgt, x, y, prm1);
					}
					break;
				case 16:	// F
					Hue(pxl_R, pxl1, ab1, prm1);
					break;
				case 19:	// n[tg[
					Halftone(&pxl1[ab1], x, y, prm1);
					break;
				case 20:	// n[tg[iVj
					Halftone2(&pxl1[ab1], x, y, prm1);
					break;
				case 21:	// 2l摜
					TwoColor(pxl1, ab1, stride1, wdh, hgt, x, y, BrtBorder, (BYTE)max, (BYTE)min, rate, false);
					break;
				case 22:	// 2l摜ifBUj
					TwoColor(pxl1, ab1, stride1, wdh, hgt, x, y, BrtBorder, (BYTE)max, (BYTE)min, rate, true);
					break;
				}
			}
		}
		
		switch (index)
		{
		case 17:	// ~`
			if(!prm1)
				break;
			else
				ZeroMemory(pxl1, stride1*hgt*sizeof(BYTE));
			
			Square(pxl_R, path_mask, bpp, stride1, wdh, hgt);
			
			int size;
			wdh < hgt ? size = wdh : size = hgt;
			Circle(pxl_R, pxl1, bpp, stride1, size/2-1, size/2-1, -1,   -1,   prm1);
			Circle(pxl_R, pxl1, bpp, stride1, size/2,   size/2-1, size, -1,   prm1);
			Circle(pxl_R, pxl1, bpp, stride1, size/2-1, size/2,   -1,   size, prm1);
			Circle(pxl_R, pxl1, bpp, stride1, size/2,   size/2,   size, size, prm1);
			break;
		case 18:	// A`GCAX
			switch (prm1)
			{
			case 1:
				AntiAlias(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt, 2);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias2(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				break;
			case 2:
				AntiAlias(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt, 2);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias2(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias3(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				break;
			case 3:
				AntiAlias(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt, 2);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias2(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias3(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				memcpy(pxl_R, pxl1, stride1*hgt*sizeof(BYTE));
				AntiAlias3(pxl_R, pxl1, path_mask, bpp, stride1, wdh, hgt);
				break;
			}
			break;
		}
		
		st = Bmp_W->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"Bmp_WbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox(GetFocus(),"Bmp_WbNł܂","",MB_OK);
	}
	
	SAFE_DELETE_ARRAY(pxl_R);
	SAFE_DELETE_ARRAY(pxl7R);
	SAFE_DELETE_ARRAY(pxl7G);
	SAFE_DELETE_ARRAY(pxl7B);
	return st;
}// Effect1

// ʂ̓Kp2
// flag_Preview : vr[̂Ƃ TRUE
// Bmp_R        : ǂݍݗprbg}bvIuWFNg
// Bmp_W        : ݗprbg}bvIuWFNg
// path         : GtFNg͈̓pX
// index        : GtFNgԍ
// prm1         : XC_̈ʒu
Status Effect2(bool flag_Preview, Bitmap *Bmp_R, Bitmap *Bmp_W, GraphicsPath *path, int index, UINT prm1)
{
	Status	st = GenericError;
	
	if(!Bmp_R || !Bmp_W){
		return st;
	}
	
	Graphics gBmp(Bmp_W);
	Rect rc(0, 0, Bmp_W->GetWidth(), Bmp_W->GetHeight());
	
	if(flag_Preview){
		st = gBmp.DrawImage(Bmp_R, rc);
	}
	
	if(index >= 23 && index <= 29){
		ImageAttributes	imAtt;
		switch (index)
		{
		case 23:
			Set_ColorRotateAttrRed(prm1, &imAtt);
			break;
		case 24:
			Set_ColorRotateAttrGreen(prm1, &imAtt);
			break;
		case 25:
			Set_ColorRotateAttrBlue(prm1, &imAtt);
			break;
		case 26:
			Set_ColorTranslateAttrRed(prm1, &imAtt);
			break;
		case 27:
			Set_ColorTranslateAttrGreen(prm1, &imAtt);
			break;
		case 28:
			Set_ColorTranslateAttrBlue(prm1, &imAtt);
			break;
		case 29:
			Set_ColorTranslateAttrAlpha(prm1, &imAtt);
			break;
		}
		if(path){
			st = gBmp.SetClip(path);
		}
		st = gBmp.DrawImage(Bmp_R, rc, 0, 0, Bmp_R->GetWidth(), Bmp_R->GetHeight(), UnitPixel, &imAtt);
	}
	
	return st;
}// Effect2

// x␳
BYTE Luminosity(UINT clr, UINT prm1)
{
	int val;
	val = (int)(clr + prm1);
	if(val < 0)		val = 0;
	if(val > 255)	val = 255;
	return (BYTE) val;
}// Luminosity

// RgXg␳
// clr : f̊eF
// prm1: XC_̒l
// min : f̊eF̍ŏl
// max : f̊eF̍ŏl
BYTE Contrast(UINT clr, UINT prm1, float min, float max)
{
	int val;
	if(prm1 > 100){	// 
		if(clr > (min+max)/2){
			val = clr + abs(clr-(int)((min+max)/2))*(prm1-100)/100;
		}
		else if(clr < (max+min)/2){
			val = clr - abs(clr-(int)((min+max)/2))*(prm1-100)/100;
		}
	}
	else{			// ɘa
		if(clr > (min+max)/2){
			val = clr - abs(clr-(int)((min+max)/2))*(100-prm1)/100;
			if(val < (min+max)/2)	val = (int)((min+max)/2);
		}
		else if(clr < (max+min)/2){
			val = clr + abs(clr-(int)((min+max)/2))*(100-prm1)/100;
			if(val > (min+max)/2)	val = (int)((min+max)/2);
		}
	}
	if(val < 0)		val = 0;
	if(val > 255)	val = 255;
	return (BYTE) val;
}// Contrast

// ʓx
void Saturation(BYTE *pxl_W, int ab, UINT prm1)
{
	float	val,sub,lum;
	int		i;
	
	lum =	(pxl_W[ab+0] * 0.114f) +
			(pxl_W[ab+1] * 0.587f) +
			(pxl_W[ab+2] * 0.299f) + 0.5f;
	
	for(i=0;i<3;i++){
		sub = (float) pxl_W[ab+i] - lum;
		val = pxl_W[ab+i] + (sub / 255) * (prm1 - 255);
		if(val > 255){
			val = 255;
		}
		else if(val < 0){
			val = 0;
		}
		pxl_W[ab+i] = (BYTE) val;
	}
}// Saturation

// F]
BYTE Negative(BYTE clr, UINT prm1)
{
	if(prm1 == 1)
		clr = ~clr;
	return clr;
}// Negative

// OCXP[
void Monotone(BYTE *pxl)
{
	double	luminance =	(pxl[0] * 0.114) +
						(pxl[1] * 0.587) +
						(pxl[2] * 0.299) + 0.5;
	pxl[0] = (BYTE) luminance;
	pxl[1] = (BYTE) luminance;
	pxl[2] = (BYTE) luminance;
}// Monotone

// \[[V
BYTE Sola(UINT clr, UINT prm1, int clr2)
{
	BYTE val = (BYTE) clr;
	if(prm1)
		val = (BYTE) clr2;
	return  val;
}// Sola

// |X^[[V
BYTE Post(UINT clr, UINT prm1)
{
	int val;
	val = clr - (clr % (prm1+1));
	if(val < 0)		val = 0;
	if(val > 255)	val = 255;
	return (BYTE) val;
}// Post

// UCN
void Mosaic(BYTE *pxl_R, DWORD *pxl7R, DWORD *pxl7G, DWORD *pxl7B, int bpp, int wdh, int hgt, int stride, int size)
{
	if(!pxl_R){
		return;
	}
	
	int n,x,y;
	
	if(size > wdh / 2)
		size = wdh / 2;
	if(size > hgt / 2)
		size = hgt / 2;
	
	int	wdh2 = wdh - (wdh % size);
	for(y=0;y<hgt;y++){
		for(x=0;x<wdh;x++){
			int ab = stride*y+x*bpp/8;
			pxl7R[(y/size)*(wdh2/size+1)+x/size] += pxl_R[ab+2];
			pxl7G[(y/size)*(wdh2/size+1)+x/size] += pxl_R[ab+1];
			pxl7B[(y/size)*(wdh2/size+1)+x/size] += pxl_R[ab+0];
		}
	}
	for(y=0;y<hgt/size+1;y++){
		for(x=0;x<wdh/size+1;x++){
			if(x < wdh/size && y < hgt/size)
				n = size * size;
			else if(x >= wdh/size && y < hgt/size)
				n = (wdh % size) * size;
			else if(x < wdh/size && y >= hgt/size)
				n = size * (hgt % size);
			else
				n = (wdh % size) * (hgt % size);
			if(n){
				pxl7R[y*(wdh/size+1)+x] /= n;
				pxl7G[y*(wdh/size+1)+x] /= n;
				pxl7B[y*(wdh/size+1)+x] /= n;
			}
		}
	}
}// Mosaic

// }XNp^[gp̃}XNKp̃sNZl̎擾
int Get_Value(BYTE *pxl_R, int bpp, int stride, int wdh, int hgt, int x, int y, int *mask, int size, int i_rgb)
{
	if(!pxl_R || !mask){
		return -1;
	}
	
	int i,j,val1,val2;
	val2 = 0;
	for(j=0;j<size;j++){
		for(i=0;i<size;i++){
			val1 = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x+i-size/2, y+j-size/2, i_rgb);
			val2 += val1 * mask[j*size+i];
		}
	}
	return val2;
}// Get_Value

// }XNp^[gp̃sNZl̎擾
int Get_Pixel(BYTE *pxl_R, int bpp, int stride, int wdh, int hgt, int x, int y, int i_rgb)
{
	if(!pxl_R){
		return -1;
	}
	
	if(x < 0)		x = 0;
	if(x >= wdh)	x = wdh - 1;
	if(y < 0)		y = 0;
	if(y >= hgt)	y = hgt - 1;
	return pxl_R[y*stride+x*bpp/8+i_rgb];
}// Get_Pixel

// }XNp^[gp̃sNZl̐ݒ
void Set_Pixel(BYTE *pxl_W, int val, int bpp, int stride, int x, int y, int i_rgb)
{
	if(!pxl_W){
		return;
	}
	
	if(val > 255)	val = 255;
	if(val < 0)		val = 0;
	pxl_W[y*stride+x*bpp/8+i_rgb] = (BYTE) val;
}// Set_Pixel

// NCbN\[g̔r֐
int Cmp(const BYTE *a, const BYTE *b)
{
	return (*a - *b);
}// Cmp

// ڂ
void Blur(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	for(int i=0;i<3;i++){
		int val = Blur_Sub(pxl_R, pxl_W, bpp, stride, wdh, hgt, x, y, i, prm1);
		if(val != -1){
			Set_Pixel(pxl_W, val, bpp, stride, x, y, i);
		}
	}
}// Blur

// ڂix̂݁j
void BlurAlpha(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	int val = Blur_Sub(pxl_R, pxl_W, bpp, stride, wdh, hgt, x, y, 3, prm1);
	if(val != -1){
		Set_Pixel(pxl_W, val, bpp, stride, x, y, 3);
	}
}// BlurAlpha

int Blur_Sub(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, int idxRGB, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return -1;
	}
	
	static int mask[9]   = {1, 1, 1,
							1, 4, 1,
							1, 1, 1};
	static int mask2[25] = {1, 1, 1, 1, 1,
							1, 2, 2, 2, 1,
							1, 2, 8, 2, 1,
							1, 2, 2, 2, 1,
							1, 1, 1, 1, 1};
	int val = -1;
	if(prm1 == 1){
		val = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask, 3, idxRGB);
		if(val != -1)
			val /= 12;
	}
	else{
		val = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask2, 5, idxRGB);
		if(val != -1)
			val /= 40;
	}
	
	return val;
}// Blur_Sub

// V[v
void Sharpness(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	int mask[9]   = { 0,-1, 0,
					 -1, 5,-1,
					  0,-1, 0};
	int mask2[25] = { 0, 0,-1, 0, 0,
					  0, 0,-1, 0, 0,
					 -1,-1, 9,-1,-1,
					  0, 0,-1, 0, 0,
					  0, 0,-1, 0, 0};
	int val;
	for(int i=0;i<3;i++){
		if(prm1 == 1){
			val = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask, 3, i);
		}
		else{
			val = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask2, 5, i);
		}
		Set_Pixel(pxl_W, val, bpp, stride, x, y, i);
	}
}// Sharpness

// GbWo
void Edge(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	int i,j,val,val2[4];
	int mask[4][9] = {{ 1, 1, 0,
						1, 0,-1,
						0,-1,-1},	// ΂ߕ
					  {-1,-1,-1,
						0, 0, 0,
						1, 1, 1},	// c
					  {-1, 0, 1,
					   -1, 0, 1,
					   -1, 0, 1},	// 
					  { 0, 1, 1,
					   -1, 0, 1,
					   -1,-1, 0}	// ΂ߕ
					 };
	
	for(i=0;i<4;i++){
		for(j=0;j<9;j++){
			mask[i][j] *= prm1;
		}
	}
	for(i=0;i<3;i++){
		for(j=0;j<4;j++){
			val2[j] = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask[j], 3, i);
		}
		val = val2[0];
		for(j=1;j<4;j++){
			if(val2[j] > val)
				val = val2[j];
		}
		val /= 6;
		if(val < 0)	val = - val;
		Set_Pixel(pxl_W, val, bpp, stride, x, y, i);
	}
}// Edge

// G{X
void Emboss(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	int i;
	int mask[9] =  {-1,-1, 1,
					-1, 0, 1,
					-1, 1, 1};
	for(i=0;i<9;i++)	mask[i] *= prm1;
	for(i=0;i<3;i++){
		int val = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask, 3, i);
		val /= 8;
		val += 128;
		Set_Pixel(pxl_W, val, bpp, stride, x, y, i);
	}
}// Emboss

// mCY
void Noise(BYTE *pxl_R, BYTE *pxl_W, int ab, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	int c;
	float clr = (float)(pxl_R[ab+0] + pxl_R[ab+1] + pxl_R[ab+2]) / 3;
	if((UINT) RandTo(100) <  prm1){
		for(c=0;c<3;c++){
			if(clr < 128)
				pxl_W[ab+c] = 255;
			else
				pxl_W[ab+c] = 0;
		}
	}
	else{
		for(c=0;c<3;c++){
			pxl_W[ab+c] = pxl_R[ab+c];
		}
	}
}// Noise

// mCY
void Remove_Noise(BYTE *pxl_R, BYTE *pxl_W, int ab, int bpp, int stride, int wdh, int hgt, int x, int y, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	int val[9],k;
	for(int c=0;c<3;c++){
		k = 0;
		for(int j=-1;j<=1;j++){
			for(int i=-1;i<=1;i++){
				val[k++] = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x+i, y+j, c);
			}
		}
		qsort(val, 9, sizeof(int), (int (*)(const void*, const void*))Cmp);
		pxl_W[ab+c] = val[4];
	}
}// Remove_Noise

// F
void Hue(BYTE *pxl_R, BYTE *pxl_W, int ab, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	if (prm1 > 192)		prm1 = 192;
	else if (prm1 <  0) prm1 = 0;
	
	WORD	fr1,fr2,fg1,fg2,fb1,fb2;
	
	if(prm1 >= 0 && prm1 <= 64){
		UINT prm2 = 64 - prm1;
		fr1 = (WORD)(pxl_R[ab+2] * prm1) >> 6;	//  >> 6  / 64 ̂
		fr2 = (WORD)(pxl_R[ab+2] * prm2) >> 6;
		fg1 = (WORD)(pxl_R[ab+1] * prm1) >> 6;
		fg2 = (WORD)(pxl_R[ab+1] * prm2) >> 6;
		fb1 = (WORD)(pxl_R[ab+0] * prm1) >> 6;
		fb2 = (WORD)(pxl_R[ab+0] * prm2) >> 6;
	}
	else if(prm1 > 64 && prm1 <= 128){
		UINT prm3 = prm1 - 64;
		UINT prm4 = 128 - prm1;
		fr1 = (WORD)(pxl_R[ab+0] * prm3) >> 6;
		fr2 = (WORD)(pxl_R[ab+0] * prm4) >> 6;
		fg1 = (WORD)(pxl_R[ab+2] * prm3) >> 6;
		fg2 = (WORD)(pxl_R[ab+2] * prm4) >> 6;
		fb1 = (WORD)(pxl_R[ab+1] * prm3) >> 6;
		fb2 = (WORD)(pxl_R[ab+1] * prm4) >> 6;
	}
	else if(prm1 > 128 && prm1 <= 192){
		UINT prm5 = prm1 - 128;
		UINT prm6 = 192 - prm1;
		fr1 = (WORD)(pxl_R[ab+1] * prm5) >> 6;
		fr2 = (WORD)(pxl_R[ab+1] * prm6) >> 6;
		fg1 = (WORD)(pxl_R[ab+0] * prm5) >> 6;
		fg2 = (WORD)(pxl_R[ab+0] * prm6) >> 6;
		fb1 = (WORD)(pxl_R[ab+2] * prm5) >> 6;
		fb2 = (WORD)(pxl_R[ab+2] * prm6) >> 6;
	}
	pxl_W[ab+2] = (BYTE)(fr2 + fb1);
	pxl_W[ab+1] = (BYTE)(fg2 + fr1);
	pxl_W[ab+0] = (BYTE)(fb2 + fg1);
}// Hue

// ~`
void Circle(BYTE *pxl_R, BYTE *pxl_W, int bpp, int stride, int x1, int y1, int x2, int y2, UINT prm1)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	Color	clr;
	int		x,y,x3,y3,ab1,ab2,wdh,hgt;
	float	a,r_x,r_y,r1,r2;
	
	wdh = abs(x2 - x1) * 2;
	hgt = abs(y2 - y1) * 2;
	
	y = y1;
	while(y != y2){
		x = x1;
		while(x != x2){
			if(x == x1 || y == y1){
				r_x = r_y = 1;
			}
			else{
				a = (float)abs(y-y1) / abs(x-x1);
				if(x1 < x2)
					x3 = x;
				else
					x3 = wdh - x;
				if(y1 < y2)
					y3 = y;
				else
					y3 = hgt - y;
				if(x3 >= y3)
					r2 = (float)sqrt((wdh/2)*(wdh/2) + (wdh/2*a)*(wdh/2*a));
				else
					r2 = (float)sqrt((hgt/2/a)*(hgt/2/a) + (hgt/2)*(hgt/2));
				r1 = (float)sqrt((x-x1)*(x-x1) + (y-y1)*(y-y1));
				if(r2 == 0){
					r_x = r_y = 1;
				}
				else{
					r_x = (1 - (r1 / r2) * (r1 / r2)) * (1 - wdh/2 / r2) + (wdh/2 / r2);
					r_y = (1 - (r1 / r2) * (r1 / r2)) * (1 - hgt/2 / r2) + (hgt/2 / r2);
				}
			}
			ab1 = stride*y+x*bpp/8;
			ab2 = stride*((int)((y-y1)*r_y)+y1)+((int)((x-x1)*r_x)+x1)*bpp/8;
			pxl_W[ab2+0] = pxl_R[ab1+0];
			pxl_W[ab2+1] = pxl_R[ab1+1];
			pxl_W[ab2+2] = pxl_R[ab1+2];
			pxl_W[ab2+3] = pxl_R[ab1+3];
			if(x1 < x2)
				x ++;
			else
				x --;
		}
		if(y1 < y2)
			y ++;
		else
			y --;
	}
}// Circle

// A`GCAXi1A4ߖTɓ܂͔̉f΁Af𔼓ɕύXj
void AntiAlias(BYTE *pxl_R, BYTE *pxl_W, BYTE *path_mask, UINT bpp, UINT stride, UINT wdh, UINT hgt, float div)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	UINT	x,y;
	BYTE	val_W;
	int		i,val_R,val_R_Max;
	POINT	offset[4] = {{-1,0},{0,-1},{1,0},{0,1}};
	
	for(y=0;y<hgt;y++){
		for(x=0;x<wdh;x++){
			if(path_mask && !path_mask[y*wdh+x]){
				continue;
			}
			if(255 == Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x, y, 3)){
				val_R_Max = -1;
				for(i=0;i<4;i++){
					val_R = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x+offset[i].x, y+offset[i].y, 3);
					if(val_R < 255 && val_R > val_R_Max){
						val_R_Max = val_R;
					}
				}
				if(val_R_Max >= 0 && val_R_Max < 255){
					val_W = (BYTE)((float)(255 + val_R_Max) / div);
					Set_Pixel(pxl_W, val_W, bpp, stride, x, y, 3);
				}
			}
		}
	}
}// AntiAlias

// A`GCAXi2Ax̉fłƂɁAx̃Of[VɕύXj
void AntiAlias2(BYTE *pxl_R, BYTE *pxl_W, BYTE *path_mask, UINT bpp, UINT stride, UINT wdh, UINT hgt)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	// 
	AntiAlias2_Sub(pxl_R, pxl_W, path_mask, bpp, stride, wdh, hgt, false);
	// c
	AntiAlias2_Sub(pxl_R, pxl_W, path_mask, bpp, stride, wdh, hgt, true);
	
}// AntiAlias2

void AntiAlias2_Sub(BYTE *pxl_R, BYTE *pxl_W, BYTE *path_mask, UINT bpp, UINT stride, UINT wdh, UINT hgt, bool bVert)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	UINT	x,x2,x3,y,max1,max2;
	int		val_RA,val_start,val_end;
	
	if(!bVert){
		max1 = hgt;
		max2 = wdh;
	}
	else{
		max1 = wdh;
		max2 = hgt;
	}
	for(y=0;y<max1;y++){
		for(x=0;x<max2-1;x++){
			BYTE val_mask;
			if(path_mask){
				if(!bVert)
					val_mask = path_mask[y*max2+x];
				else
					val_mask = path_mask[x*max1+y];
			}
			else{
				val_mask = 255;
			}
			if(!val_mask){
				continue;
			}
			if(!bVert)
				val_RA = Get_Pixel(pxl_R, bpp, stride, max2, max1, x, y, 3);
			else
				val_RA = Get_Pixel(pxl_R, bpp, stride, max1, max2, y, x, 3);
			if(val_RA <= 0 || val_RA >= 255){
				continue;
			}
			else{
				// val_start  equal_ct ̒l߂
				int equal_ct = 0;
				if(!bVert)
					AntiAlias2_Sub2(&val_start, &equal_ct, pxl_R, bpp, stride, max2, max1, x, y, val_RA);
				else
					AntiAlias2_Sub2(&val_start, &equal_ct, pxl_R, bpp, stride, max1, max2, y, x, val_RA);
				if(equal_ct == 2){	// ̕т̒[_ł͂Ȃꍇ
					continue;
				}
				UINT x_same = 0;
				for(x2=x+1;x2<max2;x2++){
					int val_RA2;
					if(!bVert)
						val_RA2 = Get_Pixel(pxl_R, bpp, stride, max2, max1, x2, y, 3);
					else
						val_RA2 = Get_Pixel(pxl_R, bpp, stride, max1, max2, y, x2, 3);
					if(val_RA != val_RA2){
						break;
					}
					x_same = x2;
				}
				if(x_same > x){
					// val_end ̒l߂
					if(!bVert)
						AntiAlias2_Sub2(&val_end, NULL, pxl_R, bpp, stride, max2, max1, x_same, y, val_RA);
					else
						AntiAlias2_Sub2(&val_end, NULL, pxl_R, bpp, stride, max1, max2, y, x_same, val_RA);
					if(val_start == val_end){
						if(val_start < val_RA){
							int sub = 0;
							if(x_same - x > 7){
								sub = (x_same - x - 6) / 2;
							}
							UINT half = (x + x_same) / 2 - sub;
							if(half < x){
								half = x;
							}
							int valD = (val_RA - val_start) / (half - x + 1);
							for(x3=x;x3<half;x3++){
								if(!bVert)
									Set_Pixel(pxl_W, val_start + valD * (x3 - x + 1), bpp, stride, x3, y, 3);
								else
									Set_Pixel(pxl_W, val_start + valD * (x3 - x + 1), bpp, stride, y, x3, 3);
							}
							UINT half2 = half + sub * 2 + 1;
							for(x3=half2;x3<=x_same;x3++){
								if(!bVert)
									Set_Pixel(pxl_W, val_RA - valD * (x3 - half2 + 1), bpp, stride, x3, y, 3);
								else
									Set_Pixel(pxl_W, val_RA - valD * (x3 - half2 + 1), bpp, stride, y, x3, 3);
							}
						}
					}
					else{
						int valD = abs(val_end - val_start) / (x_same - x + 2);
						for(x3=x;x3<=x_same;x3++){
							if(val_start < val_end){
								if(!bVert)
									Set_Pixel(pxl_W, val_start + valD * (x3 - x + 1), bpp, stride, x3, y, 3);
								else
									Set_Pixel(pxl_W, val_start + valD * (x3 - x + 1), bpp, stride, y, x3, 3);
							}
							else{
								if(!bVert)
									Set_Pixel(pxl_W, val_start - valD * (x3 - x + 1), bpp, stride, x3, y, 3);
								else
									Set_Pixel(pxl_W, val_start - valD * (x3 - x + 1), bpp, stride, y, x3, 3);
							}
						}
					}
				}
			}
		}
	}
}// AntiAlias2_Sub

// wW4ߖT̓x߁AwW̓xႢ̂2ȏ゠Ƃ͍ŏlAłȂ΍ől val ɓ
void AntiAlias2_Sub2(int *val, int *equal_ct, BYTE *pxl_R, UINT bpp, UINT stride, UINT wdh, UINT hgt, UINT x, UINT y, int val_RA)
{
	if(!pxl_R || !val){
		return;
	}
	
	int				i,val_next;
	static POINT	offset[4] = {{-1,0},{0,-1},{1,0},{0,1}};
	
	// 4ߖT̓x߂
	int smaller_ct = 0;
	int val_min = 255;
	int val_max = 0;
	for(i=0;i<4;i++){
		val_next = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x+offset[i].x, y+offset[i].y, 3);
		// 菬lA܂͓l̏ꍇ͐
		if(val_next < val_RA){
			smaller_ct ++;
		}
		else if(equal_ct && val_next == val_RA){
			(*equal_ct) ++;
		}
		// ŏl߂
		if(val_next < val_min){
			val_min = val_next;
		}
		// ől߂
		if(val_next > val_max){
			val_max = val_next;
		}
	}
	if(smaller_ct >= 2){
		*val = val_min;
	}
	else{
		*val = val_max;
	}
}// AntiAlias2_Sub2

// A`GCAXi3Aڂj
void AntiAlias3(BYTE *pxl_R, BYTE *pxl_W, BYTE *path_mask, UINT bpp, UINT stride, UINT wdh, UINT hgt)
{
	if(!pxl_R || !pxl_W){
		return;
	}
	
	static int		mask[9]  = {1, 1, 1,
								1, 1, 1,
								1, 1, 1};
	static POINT	offset[4] = {{-1,0},{0,-1},{1,0},{0,1}};
	UINT			i,x,y,val1,val2,val3;
	
	for(y=0;y<hgt;y++){
		for(x=0;x<wdh;x++){
			if(path_mask && !path_mask[y*wdh+x]){
				continue;
			}
			val1 = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x, y, 3);
			if(val1 > 0){	// f̓x 0 傫Ƃ
				bool flag = true;
				for(i=0;i<4;i++){
					val2 = Get_Pixel(pxl_R, bpp, stride, wdh, hgt, x+offset[i].x, y+offset[i].y, 3);
					if(val2 == 0){
						flag = false;
						break;
					}
				}
				if(flag){	// 4 ߖT̉f̓x 0 傫Ƃ
					val3 = Get_Value(pxl_R, bpp, stride, wdh, hgt, x, y, mask, 3, 3);
					if(val3 != -1){
						val3 /= 9;
						Set_Pixel(pxl_W, val3, bpp, stride, x, y, 3);
					}
				}
			}
		}
	}
}// AntiAlias3

// n[tg[
void Halftone(BYTE *clr, int x, int y, UINT prm1)
{
	if(prm1 <= 0){
		return;
	}
	
	static int	size_list[4]	= {2,3,4,8};
	static int	pattern1[4]		= { 0, 2,
									3, 1 };
	static int	pattern2[9]		= { 6, 8, 4,
									1, 0, 3,
									5, 2, 7 };
	static int	pattern3[16]	= {  0, 8, 2,10,
									12, 4,14, 6,
									 3,11, 1, 9,
									15, 7,13, 5 };
	static int	pattern4[64]	= {  0,32, 8,40, 2,34,10,42,
									48,16,56,24,50,18,58,26,
									12,44, 4,36,14,46, 6,38,
									60,28,52,20,62,30,54,22,
									 3,35,11,43, 1,33, 9,41,
									51,19,59,27,49,17,57,25,
									15,47, 7,39,13,45, 5,37,
									63,31,55,23,61,29,53,21 };
	int		size,index;
	float	n,val;
	int		*pattern = NULL;
	
	index = (prm1-1)%4;
	size = size_list[index];
	n = 256.0f/(size*size);
	
	switch(index)
	{
	case 0:
		pattern = pattern1;
		break;
	case 1:
		pattern = pattern2;
		break;
	case 2:
		pattern = pattern3;
		break;
	case 3:
		pattern = pattern4;
		break;
	}
	if(pattern){
		val = (float)(pattern[(y%size)*size+x%size]+1)*n-1;
		Halftone_Sub(clr, x, y, val, prm1);
	}
}// Halftone

// n[tg[iVj
void Halftone2(BYTE *clr, int x, int y, UINT prm1)
{
	if(prm1 <= 0){
		return;
	}
	
	static int	size_list[4]	= {3,5,7,9};
	static int	pattern1[9]		= { 8, 4, 7,
									1, 0, 3,
									5, 2, 6 };
	static int	pattern2[25]	= { 22, 15, 11, 18, 21,
									19, 8, 4, 7, 14,
									12, 1, 0, 3, 10,
									16, 5, 2, 6, 17,
									23, 20, 9, 13, 24 };
	static int	pattern3[49]	= { 48, 39, 35, 23, 31, 43, 47,
								    44, 27, 15, 11, 18, 26, 38,
									32, 19, 8, 4, 7, 14, 30,
									24, 12, 1, 0, 3, 10, 22,
									36, 16, 5, 2, 6, 17, 34,
									40, 28, 20, 9, 13, 25, 42,
									45, 41, 33, 21, 29, 37, 46 };
	static int	pattern4[81]	= { 80, 67, 63, 47, 39, 55, 71, 75, 79,
									76, 59, 43, 35, 23, 31, 51, 58, 66,
									72, 52, 27, 15, 11, 18, 26, 42, 62,
									56, 32, 19, 8, 4, 7, 14, 30, 46,
									40, 24, 12, 1, 0, 3, 10, 22, 38,
									48, 36, 16, 5, 2, 6, 17, 34, 54,
									64, 44, 28, 20, 9, 13, 25, 50, 70,
									68, 60, 49, 33, 21, 29, 41, 57, 74,
									77, 73, 69, 53, 37, 45, 61, 65, 78 };
	int		size,index;
	float	n,val;
	int		*pattern = NULL;
	
	index = (prm1-1)%4;
	size = size_list[index];
	n = 256.0f/(size*size);
	
	switch(index)
	{
	case 0:
		pattern = pattern1;
		break;
	case 1:
		pattern = pattern2;
		break;
	case 2:
		pattern = pattern3;
		break;
	case 3:
		pattern = pattern4;
		break;
	}
	if(pattern){
		val = (float)(pattern[(y%size)*size+x%size]+1)*n-1;
		Halftone_Sub(clr, x, y, val, prm1);
	}
}// Halftone2

void Halftone_Sub(BYTE *clr, int x, int y, float val, UINT prm1)
{
	if(prm1 <= 0){
		return;
	}
	
	int		i;
	float	av;
	
	switch ((prm1-1)/4)
	{
	case 0:	// 2l摜
		av = (float)(clr[0]+clr[1]+clr[2])/3;
		for(i=0;i<3;i++){
			if(val >= av)	clr[i] = 0;
			else		clr[i] = 255;
		}
		break;
	case 1:	// 8F摜
		for(i=0;i<3;i++){
			if(val >= clr[i])	clr[i] = 0;
			else			clr[i] = 255;
		}
		break;
	case 2:	// 27F摜
		for(i=0;i<3;i++){
			if(val >= clr[i]*1.25f)		// 1.25 ͓K
				clr[i] = 0;
			else if(val >= clr[i]*0.75f)	// 0.75 ͓K
				clr[i] = 128;
			else
				clr[i] = 255;
		}
	}
}// Halftone_Sub

// 2l摜
void TwoColor(BYTE *pxl_W, int ab, int stride, int wdh, int hgt, int x, int y, BYTE BrtBorder, BYTE BrtMax, BYTE BrtMin, float rate, bool flag_Dither)
{
	if(!pxl_W){
		return;
	}
	
	static BRGB	bRgb[2] = {{0,0,0},{255,255,255}};
	int			i,p_num;
	
	BYTE brt = (pxl_W[ab+0] + pxl_W[ab+1] + pxl_W[ab+2]) / 3;
	if(BrtMin != BrtMax){
		if(brt <= BrtBorder)
			p_num = 0;
		else
			p_num = 1;
	}
	else{
		if(brt >= (int)(255 * rate))
			p_num = 0;
		else
			p_num = 1;
	}
	if(flag_Dither){
		Dithering(x, y, wdh, hgt, stride, pxl_W, bRgb[p_num]);
	}
	for(i=0;i<3;i++){
		pxl_W[ab+i] = (BYTE)(p_num * 255);
	}
}// TwoColor

// 0 ` max ܂ł̗Ԃ
int RandTo(int max)
{
	return (int)((float)max * rand() / (RAND_MAX + 1.0f));
}// RandTo

// `ɂi`⊮@ɂkj
void Square(BYTE *pxl_R, BYTE *path_mask, int bpp, int stride, int wdh, int hgt)
{
	if(!pxl_R){
		return;
	}
	
	int		x,y,x2,y2,ab1,ab2,wdh2 = wdh,hgt2 = hgt;
	int		x0,y0,x1,y1;
	float	rate_x,rate_y,dx1,dy1,dx2,dy2,xr,yr;
	BYTE	*pxl = NULL;
	pxl = new BYTE [stride*hgt*sizeof(BYTE)];
	memcpy(pxl, pxl_R, stride*hgt*sizeof(BYTE));
	(wdh > hgt) ? wdh2 = hgt : hgt2 = wdh;
	rate_x = (float)wdh2 / wdh;
	rate_y = (float)hgt2 / hgt;
	for(y=0;y<hgt;y++){
		for(x=0;x<wdh;x++){
			if(path_mask && !path_mask[y*wdh+x]){
				continue;
			}
			ab1 = stride*y+x*bpp/8;
			x0 = (int)(rate_x * x);
			y0 = (int)(rate_y * y);
			x1 = x0 + 1;
			y1 = y0 + 1;
			xr = rate_x * x - x0;
			yr = rate_y * y - y0;
			dx1 = x0 * (1.0f - xr) + x1 * xr;
			dy1 = y0 * (1.0f - xr) + y0 * xr;
			dx2 = x0 * (1.0f - xr) + x1 * xr;
			dy2 = y1 * (1.0f - xr) + y1 * xr;
			x2 = (int)(dx1 *  (1.0f - yr) + dx2 * yr);
			y2 = (int)(dy1 *  (1.0f - yr) + dy2 * yr);
			ab2 = stride*y2+x2*bpp/8;
			pxl_R[ab2+0] = pxl[ab1+0];
			pxl_R[ab2+1] = pxl[ab1+1];
			pxl_R[ab2+2] = pxl[ab1+2];
		}
	}
	SAFE_DELETE_ARRAY(pxl);
}// Square