#define THUMB_WDH		32			// TlC̉
#define THUMB_HGT		32			// TlC̍

Status Add_ThumbButton(HWND hTool, Bitmap *Bmp, HIMAGELIST hIml, UINT img_num, UINT index, UINT startID);
Status Change_Thumb(HWND hTool, Bitmap *Bmp, HIMAGELIST hIml, UINT index);
Status Thumb_Sub(Bitmap *Bmp, HBITMAP *hBmp);

// c[o[ɃTlCǉ
Status Add_ThumbButton(HWND hTool, Bitmap *Bmp, HIMAGELIST hIml, UINT img_num, UINT index, UINT startID)
{
	Status	st = GenericError;
	HBITMAP hBmp;
	UINT	state;

	st = Thumb_Sub(Bmp, &hBmp);
	if(st != Ok){
		if(!hBmp)
			hBmp = CreateBitmap(THUMB_WDH, THUMB_HGT, 1, 1, NULL);
	}
	
	if(ImageList_Add(hIml, (HBITMAP) hBmp, NULL) == -1){
		DeleteObject(hBmp);
		MessageBox(GetFocus(),"C[WXg쐬ł܂","",MB_OK);
		return GenericError;
	}
	DeleteObject(hBmp);
	
	// IĂ{^𖢑Iɂ
	for(UINT i=0;i<img_num;i++){
		state = SendMessage(hTool, TB_GETSTATE, startID + i, 0);
		if(state & TBSTATE_CHECKED){
			SendMessage(hTool, TB_SETSTATE, startID + i, (LPARAM) MAKELONG(TBSTATE_ENABLED, 0));
			break;
		}
	}
	
	// c[o[Ƀ{^ǉ
	TBBUTTON	tbb;
	ZeroMemory(&tbb, sizeof(TBBUTTON));
	tbb.fsStyle   = TBSTYLE_AUTOSIZE |	// {^̐ݒ (TCYݒ)
					TBSTYLE_CHECKGROUP; // {^̐ݒ (P̃{^̂ݑI\)
	tbb.fsState   = TBSTATE_ENABLED;	// {^̏ԁigp\j
	tbb.iString   = -1; 				// {^̃eLXg (Ȃ)
	tbb.iBitmap   = index;				// {^̊G
	tbb.idCommand = startID + index;		// {^̖
	SendMessage(hTool, TB_INSERTBUTTON, index, (LPARAM) &tbb);
	SendMessage(hTool, TB_SETSTATE, startID + index, (LPARAM) MAKELONG(TBSTATE_CHECKED | TBSTATE_ENABLED, 0));
	
	return st;
}// Add_ThumbButton

// TlCύX
Status Change_Thumb(HWND hTool, Bitmap *Bmp, HIMAGELIST hIml, UINT index)
{
	Status	st;
	HBITMAP hBmp;

	st = Thumb_Sub(Bmp, &hBmp);
	if(st != Ok)	return st;
	
	if(!ImageList_Replace(hIml, index, hBmp, NULL)){
		DeleteObject(hBmp);
		MessageBox(GetFocus(),"C[WXgύXł܂","",MB_OK);
		return GenericError;
	}
	DeleteObject(hBmp);
	
	InvalidateRect(hTool,NULL,FALSE);
	
	return st;
}// Change_Thumb

Status Thumb_Sub(Bitmap *Bmp, HBITMAP *hBmp)
{
	Status	st;
	int		wdh,wdh2,hgt,hgt2;
	wdh = Bmp->GetWidth();
	hgt = Bmp->GetHeight();
	if(wdh >= hgt){
		wdh2 = THUMB_WDH;
		hgt2 = THUMB_HGT * hgt / wdh;
	}
	else{
		wdh2 = THUMB_WDH * wdh / hgt;
		hgt2 = THUMB_HGT;
	}
	if(wdh2 < 1 )	wdh2 = 1;
	if(hgt2 < 1)	hgt2 = 1;
	Bitmap *thumb = (Bitmap*)(Bmp->GetThumbnailImage(wdh2, hgt2, NULL, NULL));
	st = thumb->GetLastStatus();
	if(st != Ok){
		MessageBox(GetFocus(),"thumb쐬ł܂","",MB_OK);
		return st;
	}
	
	Rect		pt;
	Color		clr;
	Bitmap		thumb2(THUMB_WDH, THUMB_HGT, PixelFormat24bppRGB);
	Graphics	gBmp(&thumb2);
	wdh = thumb->GetWidth();
	hgt = thumb->GetHeight();
	if(wdh >= hgt){
		pt.X = 0;
		pt.Y = (THUMB_HGT - hgt) / 2;
	}
	else{
		pt.X = (THUMB_WDH - wdh) / 2;
		pt.Y = 0;
	}
	clr.SetFromCOLORREF(GetSysColor(COLOR_BTNFACE));
	gBmp.FillRectangle(&SolidBrush(clr), 0, 0, THUMB_WDH, THUMB_HGT);
	gBmp.DrawImage(thumb, pt.X, pt.Y, wdh, hgt);
	SAFE_DELETE_OBJ(thumb);
	thumb2.GetHBITMAP(NULL, hBmp);
	st = thumb2.GetLastStatus();
	if(st != Ok){
		MessageBox(GetFocus(),"hBmp擾ł܂","",MB_OK);
		if(*hBmp)
			DeleteObject(*hBmp);
		return st;
	}
	return st;
}// Thumb_Sub