// Rs[^EOtBbNX J.D.FOLEY/A.VAN DAM {~ {Rs[^ p.627 ` p.629

void RgbToHls(BYTE red, BYTE green, BYTE blue, int *hue, int *lum, int *sat);
BYTE HlsToRgb_Sub(float m, float n, float hue);
void HlsToRgb(int hue, int lum, int sat, BYTE *red, BYTE *green, BYTE *blue);
void Set_HLS_Edit(HWND hDlg, char *ss_r, char *ss_g, char *ss_b);

// _ľܓĐɂ
inline int Round(float val)
{
	return (int)(val + 0.5f);
}// Round

// 3̕_̍őlԂ
inline float Maxf3(float a, float b, float c)
{
	float max = a;
	if(b > max)	max = b;
	if(c > max)	max = c;
	return max;
}// Maxf3

// 3̕_̍ŏlԂ
inline float Minf3(float a, float b, float c)
{
	float min = a;
	if(b < min)	min = b;
	if(c < min)	min = c;
	return min;
}// Minf3

// RGB  HLS ɕϊ
void RgbToHls(BYTE red, BYTE green, BYTE blue, int *hue, int *lum, int *sat)
{
	float	r,g,b,h,l,s,rc,gc,bc,max,min;
	
	r = (float) red   / 255;
	g = (float) green / 255;
	b = (float) blue  / 255;
	max = Maxf3(r, g, b);
	min = Minf3(r, g, b);
	l = (max + min) / 2;
	if(max == min){
		s = 0;
		h = 0;
	}
	else{
		if(l <= 0.5f){
			s = (max - min) / (max + min);
		}
		else{
			s = (max - min) / (2 - max - min);
		}
		rc = (max - r) / (max - min);
		gc = (max - g) / (max - min);
		bc = (max - b) / (max - min);
		if(r == max){
			h = bc - gc;
		}
		else if(g == max){
			h = 2 + rc - bc;
		}
		else if(b == max){
			h = 4 + gc - rc;
		}
		h *= 60;
		if(h < 0){
			h += 360;
		}
	}
	*hue = Round(h);
	*lum = Round(l * 100);
	*sat = Round(s * 100);
}// RgbToHls

BYTE HlsToRgb_Sub(float m, float n, float hue)
{
	float val;
	
	if(hue > 360){
		hue -= 360;
	}
	if(hue < 0){
		hue += 360;
	}
	if(hue < 60){
		val = m + (n - m) * hue / 60;
	}
	else if(hue < 180){
		val = n;
	}
	else if(hue < 240){
		val = m + (n - m) * (240 - hue) / 60;
	}
	else{
		val = m;
	}
	return Round(val * 255);
}// HlsToRgb_Sub

// HLS  RGB ɕϊ
void HlsToRgb(int hue, int lum, int sat, BYTE *red, BYTE *green, BYTE *blue)
{
	float	h,l,s,m,n;
	
	h = (float) hue;
	l = (float) lum / 100;
	s = (float) sat / 100;
	if(l <= 0.5f){
		n = l * (1.0f + s);
	}
	else{
		n = l + s - l * s;
	}
	m = 2 * l - n;
	if(s == 0){
		*red = *green = *blue = Round(l * 255);
	}
	else{
		*red   = HlsToRgb_Sub(m, n, h + 120);
		*green = HlsToRgb_Sub(m, n, h);
		*blue  = HlsToRgb_Sub(m, n, h - 120);
	}
}// HlsToRgb

void Set_HLS_Edit(HWND hDlg, char *ss_r, char *ss_g, char *ss_b)
{
	int		hue,lum,sat;
	char	ss_h[4],ss_l[4],ss_s[4];
	
	RgbToHls(atoi(ss_r), atoi(ss_g), atoi(ss_b), &hue, &lum, &sat);
	
	_itoa(hue, ss_h, 10);
	_itoa(lum, ss_l, 10);
	_itoa(sat, ss_s, 10);
	
	SendDlgItemMessage(hDlg, IDC_EDIT4, WM_SETTEXT, 0, (LPARAM) ss_h);
	SendDlgItemMessage(hDlg, IDC_EDIT5, WM_SETTEXT, 0, (LPARAM) ss_l);
	SendDlgItemMessage(hDlg, IDC_EDIT6, WM_SETTEXT, 0, (LPARAM) ss_s);
}// Set_HLS_Edit
