// Source code from the MSDN Library (Icons in Win32, ICONS.C)

#define ICON_MAX		32			// ǂݍމ摜̍ő吔
#define ICON_PNG_MAX	256			// ǂݍ PNG f[^̍ő吔
#define PNGICON_WIDTH	256			// ACRȏ̏ꍇ́APNG t@C`ŕۑ

typedef struct
{
	BYTE		bWidth; 			// Width, in pixels, of the image
	BYTE		bHeight;			// Height, in pixels, of the image
	BYTE		bColorCount;		// Number of colors in image (0 if >= 8bpp)
	BYTE		bReserved;			// Reserved (must be 0)
	WORD		wPlanes;			// Color PlanesiJ[\̏ꍇ̓zbgX|bgXWj
	WORD		wBitCount;			// Bits per pixeliJ[\̏ꍇ̓zbgX|bgYWj
	DWORD		dwBytesInRes;		// How many bytes in this resource?
	DWORD		dwImageOffset;		// Where in the file is this image?
} ICONDIRENTRY, *LPICONDIRENTRY;

typedef struct
{
	WORD			wReserved;			// Reserved (must be 0)
	WORD			wType;				// Resource Type (1 for icons)
	WORD			wCount;				// How many images?
	ICONDIRENTRY	idEntries[ICON_MAX];// An entry for each image (wCount of 'em)
} ICONDIR, *LPICONDIR;

typedef struct
{
	bool			bPng;			// PNG tO
	POINT			hotspot;		// J[\̃zbgX|bg
	int				idxPng;			// g_iPng ̔ԍ
	UINT	Width, Height, Colors;	// Width, Height and bpp 
	DWORD			dwNumBytes;		// How many bytes? 
	LPBYTE			pData;			// ptr to DIB data
	LPBITMAPINFO	pbmiX;			// DIB BITMAPINFO for XOR mask
	LPBITMAPINFO	pbmiA;			// DIB BITMAPINFO for AND mask
	LPBYTE			pXOR;			// DIB bits for XOR mask
	LPBYTE			pAND;			// DIB bits for AND mask
} ICONIMAGE, *LPICONIMAGE;

typedef struct
{
	LPSTREAM		pStrm;
} ICONPNG, *LPICONPNG;

ICONIMAGE	g_iImg[ICON_MAX] = {0};		// ACR̃CtHwb_ƃsNZf[^
ICONPNG		g_iPng[ICON_PNG_MAX] = {0};	// ǂݍݗp PNG t@C̃f[^

int		Load_Icon(char *filename);
bool	Set_ImageData( LPICONIMAGE pIImg );
bool	Set_BmiAND( LPICONIMAGE pIImg );
bool	Save_Icon(int num, char *filename, bool flag_cursor);
DWORD	CalculateImageOffset( ICONDIR id, UINT nIndex );
int		Get_IconNum(char *filename);

// ACR t@Cf[^ǂݍ
int Load_Icon(char *filename)
{
	HANDLE		hFile;
	DWORD		dwRead;
	bool		flag_cursor;	// ACR:false ,J[\:true
	ICONDIR		id;				// ACR̃t@Cwb_
	int			i;
	
	hFile = CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,
						NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return 0;
	}
	// Read the Reserved word
	ReadFile( hFile, &(id.wReserved), sizeof( WORD ), &dwRead, NULL );
	if(id.wReserved != 0)	return 0;
	// Read the Type word - it is 1 for icons, the other cursors
	ReadFile( hFile, &(id.wType), sizeof( WORD ), &dwRead, NULL );
	flag_cursor = id.wType != 1 ? true : false;
	// Read the count - how many images in this file?
	ReadFile( hFile, &(id.wCount), sizeof( WORD ), &dwRead, NULL );
	id.wCount = id.wCount < ICON_MAX ? id.wCount : ICON_MAX;
	// Read the ICONDIRENTRY elements
	ReadFile( hFile, id.idEntries, id.wCount * sizeof(ICONDIRENTRY), &dwRead, NULL );
	// Release memories
	for(i=0;i<ICON_MAX;i++){
		SAFE_DELETE_ARRAY(g_iImg[i].pData);
		SAFE_DELETE_ARRAY_BYTE(g_iImg[i].pbmiX);
		SAFE_DELETE_ARRAY_BYTE(g_iImg[i].pbmiA);
		SAFE_DELETE_ARRAY(g_iImg[i].pXOR);
		SAFE_DELETE_ARRAY(g_iImg[i].pAND);
	}
	for(i=0;i<ICON_PNG_MAX;i++){
		SAFE_RELEASE(g_iPng[i].pStrm);
	}
	// Loop through and read in each image
	int ct = 0;
	for(i=0;i<id.wCount;i++)
	{
		if(flag_cursor){
			g_iImg[i].hotspot.x = id.idEntries[i].wPlanes;
			g_iImg[i].hotspot.y = id.idEntries[i].wBitCount;
		}
		else{
			g_iImg[i].hotspot.x = 0;
			g_iImg[i].hotspot.y = 0;
		}
		// Allocate memory to hold the image
		g_iImg[i].pData = new BYTE [id.idEntries[i].dwBytesInRes];
		// Seek to the location in the file that has the image
		SetFilePointer( hFile, id.idEntries[i].dwImageOffset, NULL, FILE_BEGIN );
		// Read the image data
		ReadFile( hFile, g_iImg[i].pData, id.idEntries[i].dwBytesInRes, &dwRead, NULL );
		// Set the image data
		if(!_mbsncmp(g_iImg[i].pData+1, (UCHAR*)"PNG", 3) && ct < ICON_PNG_MAX){
			HGLOBAL	hMem  = GlobalAlloc(GPTR, id.idEntries[i].dwBytesInRes);
			LPBYTE	pData = (LPBYTE) GlobalLock(hMem);
			SetFilePointer( hFile, id.idEntries[i].dwImageOffset, NULL, FILE_BEGIN );
			ReadFile( hFile, pData, id.idEntries[i].dwBytesInRes, &dwRead, NULL );
			CreateStreamOnHGlobal(hMem, TRUE, &g_iPng[ct].pStrm);	// 2Ԗڂ̈ TRUE ɂ pStrm ̉ hMem ipData j
			GlobalUnlock(hMem);
			g_iImg[i].idxPng = ct;
			g_iImg[i].bPng = true;
			ct ++;
		}
		else{
			Set_ImageData( &g_iImg[i] );
			g_iImg[i].bPng = false;
		}
		SAFE_DELETE_ARRAY(g_iImg[i].pData);
	}
	CloseHandle(hFile);
	return id.wCount;
}// Load_Icon

bool Set_ImageData( LPICONIMAGE pIImg )
{
	LPBITMAPINFO	pbmiX;
	LPBYTE			pXOR;
	LPBYTE			pAND;
	
	// Sanity check
	if( pIImg == NULL )
		return false;
	// BITMAPINFO is at beginning of bits
	pbmiX = (LPBITMAPINFO) pIImg->pData;
	// BITMAPINFO(XOR)̃mۂARs[
	int sizePbmiX = BmiSize(&(pbmiX->bmiHeader));
	pIImg->pbmiX = (LPBITMAPINFO) new BYTE [sizePbmiX];
	memcpy(pIImg->pbmiX, pbmiX, sizePbmiX);
	pIImg->pbmiX->bmiHeader.biHeight /= 2;
	if(pIImg->pbmiX->bmiHeader.biSize != sizeof(BITMAPINFOHEADER)){
		SAFE_DELETE_ARRAY_BYTE(pIImg->pbmiX);
		return false;
	}
	// XOR bits follow the header and color table
	pXOR = pIImg->pData + sizePbmiX;
	// sNZf[^(XOR)̃mۂARs[
	int sizePXOR = (pIImg->pbmiX->bmiHeader.biHeight
					* BytesPerLine((LPBITMAPINFOHEADER)&(pIImg->pbmiX->bmiHeader)));
	pIImg->pXOR = new BYTE [sizePXOR];
	memcpy(pIImg->pXOR, pXOR, sizePXOR);
	// BITMAPINFO(AND)̃mۂARs[
	Set_BmiAND(pIImg);
	// AND bits follow the XOR bits
	pAND = pXOR + sizePXOR;
	int sizePAND = pIImg->pbmiA->bmiHeader.biSizeImage;
	// sNZf[^(AND)̃mۂARs[
	pIImg->pAND = new BYTE [sizePAND];
	memcpy(pIImg->pAND, pAND, sizePAND);
	return true;
}// Set_ImageData

// AND mask ̃rbg}bvCtH\̂ݒ肷
bool Set_BmiAND( LPICONIMAGE pIImg )
{
	if(!pIImg->pbmiX)
		return false;
	pIImg->pbmiA = (LPBITMAPINFO) new BYTE [sizeof(BITMAPINFO) + (2 * sizeof( RGBQUAD ))];
	pIImg->pbmiA->bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
	pIImg->pbmiA->bmiHeader.biWidth = pIImg->pbmiX->bmiHeader.biWidth;
	pIImg->pbmiA->bmiHeader.biHeight = pIImg->pbmiX->bmiHeader.biHeight;
	pIImg->pbmiA->bmiHeader.biPlanes = 1;
	pIImg->pbmiA->bmiHeader.biBitCount = 1;
	pIImg->pbmiA->bmiHeader.biCompression = BI_RGB;
	pIImg->pbmiA->bmiHeader.biSizeImage = WIDTHBYTES(pIImg->pbmiA->bmiHeader.biWidth * 
				pIImg->pbmiA->bmiHeader.biPlanes * pIImg->pbmiA->bmiHeader.biBitCount) * 
				pIImg->pbmiA->bmiHeader.biHeight;
	pIImg->pbmiA->bmiHeader.biXPelsPerMeter = 0;
	pIImg->pbmiA->bmiHeader.biYPelsPerMeter = 0;
	pIImg->pbmiA->bmiHeader.biClrUsed = 0;
	pIImg->pbmiA->bmiHeader.biClrImportant = 0;
	pIImg->pbmiA->bmiColors[0].rgbRed = 0;
	pIImg->pbmiA->bmiColors[0].rgbGreen = 0;
	pIImg->pbmiA->bmiColors[0].rgbBlue = 0;
	pIImg->pbmiA->bmiColors[0].rgbReserved = 0;
	pIImg->pbmiA->bmiColors[1].rgbRed = 255;
	pIImg->pbmiA->bmiColors[1].rgbGreen = 255;
	pIImg->pbmiA->bmiColors[1].rgbBlue = 255;
	pIImg->pbmiA->bmiColors[1].rgbReserved = 0;
	return true;
}// Set_BmiAND

// t@CɃACR f[^
bool Save_Icon(int num, char *filename, bool flag_cursor)
{
	HANDLE	hFile;
	DWORD	dwWrite;
	ICONDIR	id;
	int		i;
	
	if(!g_iImg[0].pData)
		return 0;
	// open the file
	hFile = CreateFile(filename,GENERIC_WRITE,FILE_SHARE_WRITE,
						NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return 0;
	}
	id.wReserved = 0;
	id.wType = 1 + flag_cursor;
	id.wCount = num;
	// Write the Reserved word
	WriteFile( hFile, &(id.wReserved), sizeof( WORD ), &dwWrite, NULL );
	// Write the Type word - make sure it is 1 for icons
	WriteFile( hFile, &(id.wType), sizeof( WORD ), &dwWrite, NULL );
	// Write the count - how many images in this file?
	WriteFile( hFile, &(id.wCount), sizeof( WORD ), &dwWrite, NULL );
	for(i=0;i<id.wCount;i++)
	{
		// Convert internal format to ICONDIRENTRY
		if(g_iImg[i].Width < PNGICON_WIDTH && g_iImg[i].Height < PNGICON_WIDTH){
			id.idEntries[i].bWidth    = (BYTE) g_iImg[i].Width;
			id.idEntries[i].bHeight   = (BYTE) g_iImg[i].Height;
		}
		else{
			id.idEntries[i].bWidth    = 0;
			id.idEntries[i].bHeight   = 0;
		}
		if( g_iImg[i].Colors < 8 )
			id.idEntries[i].bColorCount = 1 << g_iImg[i].Colors;
		else
			id.idEntries[i].bColorCount = 0;
		id.idEntries[i].bReserved = 0;
		if(flag_cursor){
			id.idEntries[i].wPlanes   = (WORD) g_iImg[i].hotspot.x;
			id.idEntries[i].wBitCount = (WORD) g_iImg[i].hotspot.y;
		}
		else{
			id.idEntries[i].wPlanes   = 0;
			id.idEntries[i].wBitCount = 0;
		}
		
		id.idEntries[i].dwBytesInRes  = g_iImg[i].dwNumBytes;
		id.idEntries[i].dwImageOffset = CalculateImageOffset( id, i );
		// Write the ICONDIRENTRY out to disk
		WriteFile( hFile, &id.idEntries[i], sizeof( ICONDIRENTRY ), &dwWrite, NULL );
		// Did we write a full ICONDIRENTRY ?
		if( dwWrite != sizeof( ICONDIRENTRY ) )
			return 0;
	}
	for(i=0;i<id.wCount;i++)
	{
		// Write the image data to file
		WriteFile( hFile, g_iImg[i].pData, id.idEntries[i].dwBytesInRes, &dwWrite, NULL );
		if( dwWrite != id.idEntries[i].dwBytesInRes )
			return 0;
		SAFE_DELETE_ARRAY(g_iImg[i].pData);
	}
	CloseHandle(hFile);
	return 1;
}// Save_Icon

DWORD CalculateImageOffset( ICONDIR id, UINT nIndex )
{
	DWORD	dwSize;
	UINT	i;
	
	// Calculate the ICO header size
	dwSize = 3 * sizeof(WORD);
	// Add the ICONDIRENTRY's
	dwSize += id.wCount * sizeof(ICONDIRENTRY);
	// Add the sizes of the previous images
	for(i=0;i<nIndex;i++)
		dwSize += id.idEntries[i].dwBytesInRes;
	// we're there - return the number
	return dwSize;
}// CalculateImageOffset

// ACR t@CɊ܂܂摜Ԃ
int Get_IconNum(char *filename)
{
	HANDLE		hFile;
	DWORD		dwRead;
	ICONDIR		id;				// ACR̃t@Cwb_
	
	hFile = CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,
						NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return 0;
	}
	// Read the Reserved word
	ReadFile( hFile, &(id.wReserved), sizeof( WORD ), &dwRead, NULL );
	if(id.wReserved != 0)	return 0;
	// Read the Type word - it is 1 for icons, the other cursors
	ReadFile( hFile, &(id.wType), sizeof( WORD ), &dwRead, NULL );
	// Read the count - how many images in this file?
	ReadFile( hFile, &(id.wCount), sizeof( WORD ), &dwRead, NULL );
	CloseHandle(hFile);
	return id.wCount;
}// Get_IconNum
